<?php
/*
Copyright (c) 2008 http://ramui.com/. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class admin extends clsmain
{
private function show_sitemap($flag)
{
        $filename=$_SERVER['DOCUMENT_ROOT']."/sitemap.xml";
        switch ($flag){
        case "2":
            $content=trim(fw_strip_slashes(rawurldecode($_POST["sitemap"])));
            if(!@file_put_contents($filename,$content)){echo "<span style='color:red;'>Unable to save sitemap file. Please check file permission.</span>";}
            else{echo "<span style='color:green;'>Sitemap has been suscessfully saved!</span>";}
            exit;
        break;
        case "0":
            $content= is_file($filename)? file_get_contents($filename):'';}
        $this->build_head("Generate sitemap:", '<script type="text/javascript" src="script/admin.js"></script>','');
        include "include/sitemap.php";
        $this->build_footer();
}

private function generate_sitemap()
{
        $str='<?xml version="1.0" encoding="UTF-8"?>';
        $str.='<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9"';
        $str.=' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"';
        $str.=' xsi:schemaLocation="http://www.sitemaps.org/schemas/sitemap/0.9';
        $str.=' http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd">';
		$str.="\n<url><loc>http://".getenv("HTTP_HOST")."/</loc></url>";
        $query= "SELECT pagename, updated FROM ".PREFIX."pageinf WHERE indexed = 1 AND publish = 1 LIMIT 0,500";
        $result= @$this->con->query($query);
        while($row= @$result->fetch_array(MYSQL_ASSOC)){
                $str.="\n<url><loc>".BLOG_URL.urlencode($row['pagename']).".html</loc>";
                $str.="\n<lastmod>".gmdate("Y-m-d",$row['updated'])."</lastmod>";
                $str.="\n<changefreq>daily</changefreq></url>";}
        $query= "SELECT pagename, content, updated FROM ".PREFIX."postinf WHERE indexed = 1 AND publish = 1 LIMIT 0,500";
        $result= @$this->con->query($query);
        while($row= @$result->fetch_array(MYSQL_ASSOC)){
                $str.="\n<url><loc>".BLOG_URL.urlencode($row['pagename']).".html</loc>";
                $str.="\n<lastmod>".gmdate("Y-m-d",$row['updated'])."</lastmod>";
                $str.="\n<changefreq>daily</changefreq></url>";
                if(($totalpages=1+substr_count($row['content'],'<fw_pagebreak />'))>1){
                       for($i=2; $i<=$totalpages; $i++){
                             $str.="\n<url><loc>".BLOG_URL.urlencode($row['pagename']).".html?fw_pageno=$i</loc>";
                             $str.="\n<lastmod>".gmdate("Y-m-d",$row['updated'])."</lastmod>";
                             $str.="\n<changefreq>daily</changefreq></url>";
                       }
                }
        }
        $str.='</urlset>';
        echo $str;exit;
}
private function show_boardsettings()
{
        $query  = "SELECT* FROM ".PREFIX."settings";
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
		$blocksite=(($row['blocksite'])? '<span style="color:#338833;">Unblock this site..</span>' : '<span style="color:#883333;">Block this site..</span>');
		$list= glob("../templates/*",GLOB_ONLYDIR);
		$option='';
		foreach ($list as $template){
			$template=str_replace("../templates/", "", $template);
			$option.=($row['defaultstyle']==$template)? '<option selected value="'.$template.'">'.$template.'</option>' : '<option value="'.$template.'">'.$template.'</option>';}
		$this->build_head('Site information:','<script type="text/javascript" src="script/admin.js"></script>','');
        include "include/editsite.php";
        $this->build_footer();
}

private function save_boardsettings()
{
		$sitename=trim(fw_strip_slashes($_POST["sitename"]));
		$description=trim(fw_strip_slashes($_POST["description"]));
		$keywords=trim(fw_strip_slashes($_POST["keywords"]));
        $defaultstyle=trim(fw_strip_slashes($_POST["template"]));
        $commentsize=trim($_POST["commentsize"]);
		$defaultauthor=trim(fw_strip_slashes($_POST["defaultauthor"]));
        $feedsize=trim($_POST["feedsize"]);
		$listperpage=trim($_POST["listperpage"]);
		$approval=((isset($_POST["approval"]))&&($_POST["approval"]=='Y'))? 1 : 0;
		$nofollow=((isset($_POST["nofollow"]))&&($_POST["nofollow"]=='Y'))? 1 : 0;
		$autolink=((isset($_POST["autolink"]))&&($_POST["autolink"]=='Y'))? 1 : 0;
		$sitemap=((isset($_POST["sitemap"]))&&($_POST["sitemap"]!='N'))? $_POST['sitemap']:'';
		if(isset($_POST["automenu"])){
			if($_POST["menutype"]=='S'){$menutype=1;}
			elseif($_POST["menutype"]=='J'){$menutype=2;}
			else{$menutype=3;}
		}
        $query="UPDATE ".PREFIX."settings SET sitename = '%s', description = '%s', keywords = '%s', defaultstyle = '%s', defaultauthor= '%s', feedsize = %u, commentsize = %d, listperpage = %u, approval = $approval, autolink = $autolink, nofollow = $nofollow, sitemap = '$sitemap'";
		$query=sprintf($query,$this->con->real_escape_string($sitename),$this->con->real_escape_string($description),$this->con->real_escape_string($keywords),$this->con->real_escape_string($defaultstyle),$this->con->real_escape_string($defaultauthor),$feedsize,$commentsize,$listperpage);
		if(isset($_POST["automenu"])){$query.=", automenu = 1, menutype = $menutype";}
		else{$query.=", automenu = 0";}
		if(!@$this->con->query($query)){fw_message(true,$this->con->error);}
        else{fw_message(false,'Data has been updated');}
        exit;
}
private function block_site()
{
        $query  = "SELECT blocksite FROM ".PREFIX."settings";
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
		if($row['blocksite']){$response='<span style="color:#883333;">Block this site..</span>';$blocksite=0;}
		else{$response='<span style="color:#338833;">Unblock this site..</span>';$blocksite=1;}
		if(@$this->con->query("UPDATE ".PREFIX."settings SET blocksite = $blocksite")){echo $response;}exit;
}
private function show_userlist($page)
{
        $search='';
        $sortDir='Desc';
        $sortCol='date';
        if(!empty($_GET['sortCol'])){$sortCol=fw_strip_slashes($_GET['sortCol']);}
        if(!empty($_GET['sortDir'])){$sortDir=fw_strip_slashes($_GET['sortDir']);}
        if(!empty($_GET['SearchFileString'])){$search=fw_strip_slashes($_GET['SearchFileString']);}
        $this->build_head('User list', '','');
		$query= "SELECT id FROM ".PREFIX."user";
        $result = @$this->con->query($query);
        $num_rows = @$result->num_rows;
        $start_count=($page-1)*$this->list_perpage;
        $totalpage=fw_total_page($num_rows, $this->list_perpage);

        echo '<table id="list"><tr><td class="heading" style="width:20%;"><a href="index.php?qur=6M6M1&SearchFileString='.$search.'&sortCol=user&sortDir=Asc"><img src="images/up.gif" onmouseover="this.src=\'images/uph.gif\'" onmouseout="this.src=\'images/up.gif\'" /></a><a href="index.php?qur=6M6M1&SearchFileString='.$search.'&sortCol=user&sortDir=Desc"><img src="images/dn.gif" onmouseover="this.src=\'images/dnh.gif\'" onmouseout="this.src=\'images/dn.gif\'" /></a>User</td>';
        echo '<td class="heading" style="width:40%;"><a href="index.php?qur=6M6M1&SearchFileString='.$search.'&sortCol=email&sortDir=Asc"><img src="images/up.gif" onmouseover="this.src=\'images/uph.gif\'" onmouseout="this.src=\'images/up.gif\'" /></a><a href="index.php?qur=6M6M1&SearchFileString='.$search.'&sortCol=email&sortDir=Desc"><img src="images/dn.gif" onmouseover="this.src=\'images/dnh.gif\'" onmouseout="this.src=\'images/dn.gif\'" /></a>Email</td>';
		echo '<td class="heading" style="width:15%;"><a href="index.php?qur=6M6M1&SearchFileString='.$search.'&sortCol=post&sortDir=Asc"><img src="images/up.gif" onmouseover="this.src=\'images/uph.gif\'" onmouseout="this.src=\'images/up.gif\'" /></a><a href="index.php?qur=6M6M1&SearchFileString='.$search.'&sortCol=post&sortDir=Desc"><img src="images/dn.gif" onmouseover="this.src=\'images/dnh.gif\'" onmouseout="this.src=\'images/dn.gif\'" /></a>Post</td>';
		echo '<td class="heading"><a href="index.php?qur=6M6M1&SearchFileString='.$search.'&sortCol=date&sortDir=Asc"><img src="images/up.gif" onmouseover="this.src=\'images/uph.gif\'" onmouseout="this.src=\'images/up.gif\'" /></a><a href="index.php?qur=6M6M1&SearchFileString='.$search.'&sortCol=date&sortDir=Desc"><img src="images/dn.gif" onmouseover="this.src=\'images/dnh.gif\'" onmouseout="this.src=\'images/dn.gif\'" /></a><b>Date of join</b></td></tr>';
        echo '<tr><td colspan="4"><big>*</big><a title="Remove Filter" href="index.php?qur=6M6M1">User list</a></td></tr>';
        $query="SELECT tu.id, tu.user, tu.level, tu.email, tu.date, IF(ISNULL(tc.id), 0,COUNT(tc.id)) AS post FROM ".PREFIX."user tu LEFT JOIN ".PREFIX."comments tc ON tc.uid = tu.id WHERE tu.user LIKE '%%%s%%'";
		$query=sprintf($query,$this->con->real_escape_string($search));
		$query.=" GROUP BY tu.id ORDER BY $sortCol $sortDir LIMIT ".$start_count.", ".$this->list_perpage;
        $result = @$this->con->query($query);
        while($row = @$result->fetch_array(MYSQL_ASSOC))
        {
            echo '<tr onMouseOver="this.className=\'highlight\'" onMouseOut="this.className=\'normal\'">';
			$src='<img title="Active" src="images/useractive.gif" alt="A" />';
			if($row['level']==0){$src='<img title="Ban" src="images/user_ban.gif" alt="B" />';}
            echo '<td>'.$src;
            echo '<a href="index.php?qur=6M7M'.$row['id'].'">'.$row['user'].'</a></td>';
			echo '<td>'.$row['email'].'</td>';
			echo '<td style="text-align:center;">Post('.$row['post'].')</td>';
            echo '<td>'.gmdate("M d Y, H:i", $row['date']).'</td></tr>';
        }

        echo '<tr><td colspan="4"><b>No. of pages:&nbsp;'.$totalpage.'</b>&nbsp;&nbsp;&nbsp;';

        $start=(($page>10)? $page-10 : 1);
        $end=(($totalpage<=21)? $totalpage : $start+20);
        echo(($page>1)? '<a href="index.php?qur=6M6M'.($page-1).'&SearchFileString='.$search.'&sortCol='.$sortCol.'&sortDir='.$sortDir.'">Back</a>&nbsp;' : '<span style="color:#808080;">Back</span>&nbsp;');
        for($p=$start; $p<=$end; $p++){
             if($p==$page){echo '<span style="color:#808080;">['.$p.']</span>&nbsp;';}
             else{echo '[<a href="index.php?qur=6M6M'.$p.'&SearchFileString='.$search.'&sortCol='.$sortCol.'&sortDir='.$sortDir.'">'.$p.'</a>]&nbsp;';}
        }
        echo(($page<$totalpage)? '<a href="index.php?qur=6M6M'.($page+1).'&SearchFileString='.$search.'&sortCol='.$sortCol.'&sortDir='.$sortDir.'">Next</a>&nbsp;' : '<span style="color:#808080;">Next</span>&nbsp;');

        echo '</td></tr>';
        echo '<tr><td colspan="4" style="background:#e0e0e0; padding-bottom:0;">';
        echo '<form name="frmSearchList" style="float:right; margin:0; color:#000000;" onSubmit="return fw_search(\'index.php?qur=6M6M1\');">';
        echo 'Search file:&nbsp;<input name="txtSearch" style="padding-left:5px; width:180px; font-size:11px; color:#666666;" type="text" value="';
        echo (($search=='')? 'Type first few characters...' : $search);
        echo '" size="20" onClick="fw_cleartext(this);">&nbsp;<input name="Submit" type="button" style="width:80px; font-size:11px; color:#333333;" value="Search" onClick="fw_search(\'index.php?qur=6M6M1\');"></form></td></tr></table>';
        echo '</div>';
        $this->build_footer();
}
private function show_user($id)
{
        $query  = sprintf("SELECT tu.*, IF(ISNULL(tc.id), 0,COUNT(tc.id)) AS post FROM ".PREFIX."user tu, ".PREFIX."comments tc WHERE tu.id = %u AND tu.id = tc.uid",$id);
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
        $hmenu='<li><a href="index.php?qur=6M6M1">User list</a></li><li><a href="javascript:fwBan('.$id.')"><span id="ban">';
		$hmenu.=(($row['level']==0)? 'Lift ban' : 'Ban user').'</span></a></li><li><a href="javascript:fwDelete('.$id.')">Delete user</a></li>';
        $this->build_head('User: '.$row['user'],'<script type="text/javascript" src="script/admin.js"></script>',$hmenu);
		include "include/edituser.php";
        $this->build_footer();
}
public function get_query($query='')
{
        if ($this->validate_user()){
			switch ($query[1]) {
			case "1":
			  $this->show_boardsettings();
			break;
			case "2":
			  $this->save_boardsettings();
			break;
			case "12":
			  $this->block_site();
			break;
			case "3":
			  $this->show_usersettings();
			break;
			case "4":
			  $this->show_sitemap($query[2]);
			break;
			case "5":
			  $this->log_out();
			break;
			case "6":
			  $this->show_userlist($query[2]);
			break;
			case "7":
			  $this->show_user($query[2]);
			break;
			case "8":
			  $this->ban_user($query[2]);
			break;
			case "9":
			  $this->save_user($query[2]);
			break;
			case "11":
			  $this->delete_user($query[2]);
			break;
			case "13":
			  $this->show_adminsettings();
			break;
			case "14":
			  $this->save_adminsettings();
			break;
			case "15":
			  $this->generate_sitemap();
			break;
			default :
			  $this->show_admin();}
        }
        else { $this->log_in();}
}
private function show_adminsettings($message='')
{
		$query="SELECT user, email FROM ".PREFIX."admin LIMIT 0,1";
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
		$this->build_head("Admin settings:",'<script type="text/javascript" src="script/admin.js"></script>','');
		include 'include/editadmin.php';
		$this->build_footer();
}
private function save_adminsettings()
{
		$query="SELECT password FROM ".PREFIX."admin LIMIT 0,1";
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
		$password=md5(trim(fw_strip_slashes($_POST["password"])));
		if($password!==$row['password']){fw_message(true,'Please type your current password before submitting the form!');exit;}
		$email=trim(fw_strip_slashes($_POST["email"]));
		$user=trim(fw_strip_slashes($_POST["user"]));
		if(!fw_validate_user($user,$email)){fw_message(true,'Error! Invalid user name and / or email!');exit;}
		$newpassword=trim(fw_strip_slashes($_POST["newpassword"]));
		$retypepassword=trim(fw_strip_slashes($_POST["retypepassword"]));
		if((!empty($newpassword))&&(!empty($retypepassword))&&($newpassword===$retypepassword)){$newpassword=md5($newpassword);}
		else{$newpassword=$password;}
		$query=sprintf("UPDATE ".PREFIX."admin SET user = '%s', email = '%s', password = '%s'",$this->con->real_escape_string($user),$this->con->real_escape_string($email),$this->con->real_escape_string($newpassword));
		@$this->con->query($query);
		fw_message(false,'Data has been updated.');
		exit;
}
private function save_user($id)
{
        $website=trim(fw_strip_slashes(rawurldecode($_POST["website"])));
        $email=trim(fw_strip_slashes(rawurldecode($_POST["email"])));
        $query=sprintf("UPDATE ".PREFIX."user SET email = '%s', website = '%s' WHERE id = %u",$this->con->real_escape_string($email),$this->con->real_escape_string($website),$id);
        echo (@$this->con->query($query))? '<span style="color:green">Data has been updated.</span>' : '<span style="color:red">Error! '.$this->con->error.'</span>';
		exit;
}
private function ban_user($id)
{
        $query=sprintf("SELECT level FROM ".PREFIX."user WHERE id = %u",$id);
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
        if($row['level']==0){$level=9;$response='Ban user';}
		else{$level=0;$response='Lift ban';}
        $query=sprintf("UPDATE ".PREFIX."user SET level = $level WHERE id = %u",$id);
        if(@$this->con->query($query)){echo $response;}exit;
}
private function delete_user($id)
{
        $query = sprintf("DELETE tc, tu FROM ".PREFIX."comments tc, ".PREFIX."user tu WHERE tc.uid = tu.id AND tu.id = %u",$id);
        @$this->con->query($query);
        @header("Location: index.php?qur=6M6M1");
}
}
?>