<?php
/*
Copyright (c) 2008 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class post extends clsmain
{
private function show_preview()
{
		$pagename=trim(fw_strip_slashes($_POST["pagename"]));
		if(!fw_validate_pagename($pagename)){exit;}
		$pagename=$this->preview_pagename($pagename);
		$title=trim(fw_strip_slashes($_POST["title"]));
		$heads=trim(fw_strip_slashes($_POST["heads"]));
		$content=trim(fw_strip_slashes($_POST["content"]));
		$dt=time();
		$query="UPDATE ".PREFIX."preview SET title = '%s', heads = '%s', content = '%s', pagename = '%s', date = $dt";
		$query=sprintf($query,$this->con->real_escape_string($title),$this->con->real_escape_string($heads),$this->con->real_escape_string($content),$this->con->real_escape_string($pagename));
		@$this->con->query($query);
		$_SESSION['fw_preview']=$pagename;
		echo '<script>parent.previewPage("http://'.getenv('HTTP_HOST').DOCROOT.$pagename.'.html");</script>';
		exit;
}
private function show_edit($id='')
{
		$action='index.php?qur=2M7M'.(empty($id)? '0':$id).'M';
		$menu='<li><a href="index.php?qur=2M">Post list</a></li>';
		if($id!= ''){
			$query=sprintf("SELECT tp.*, tf.id as feedid, tf.allowfeed, IF(ISNULL(tc.id), 0,COUNT(tc.id)) AS c FROM ".PREFIX."postinf tp LEFT JOIN ".PREFIX."comments tc ON tp.id = tc.pid LEFT JOIN ".PREFIX."feed tf ON tp.id = tf.postid WHERE tp.id = %u",$id);
			$result = @$this->con->query($query);
			$row = @$result->fetch_array(MYSQL_ASSOC);
			if(empty($row['feedid'])){
				$url=str_replace("www.","", strtolower(getenv("HTTP_HOST")));
				$identifier='tag:'.$url.','.gmdate("Y-m-d",$row['date']).':'.$row['pagename'].'.html?post='.$id;
				$identifier=$this->con->real_escape_string($identifier);
				$query="INSERT INTO ".PREFIX."feed(postid, identifier) VALUES (".$row['id'].", '$identifier')";
				@$this->con->query($query);			
			}
			$menu.='<li>'.(($row['c'])? '<a href="index.php?qur=9M6M1M'.$id.'M0">Comments('.$row['c'].')</a>':'Comments(0)').'</li>';
			$menu.='<li><a href="javascript:fwDelete('.$id.')">Delete post</a></li>';
			$menu.='<li><a href="javascript:fwPublish('.$id.')"><span id="publish">'.(($row['publish'])? 'Block' : 'Publish').'</span></a></li>';
			$headerfile='../headers/'.str_replace('/', '.', $row['pagename']).'.php';
			$headers=(is_file($headerfile)? @file_get_contents($headerfile):'');
		}
		$this->build_head("Create post || Edit post",'<script type="text/javascript" src="script/editpost.js"></script>',$menu);
		include "include/editpost.php";
		$this->build_footer();
}
private function edit_post($id='',$overwrite)
{
		if(isset($_POST['btnPreview'])){$this->show_preview();}
		$pagename=trim(fw_strip_slashes($_POST["pagename"]));
		if(!fw_validate_pagename($pagename)){fw_message(true,'Error: Invaliv pagename!');exit;}
		if(substr($pagename,0,5)==='fw_blog/'){fw_message(true,'Error: please do not create page in your blog directory');exit;}
		$headers=fw_strip_slashes(trim($_POST["headers"]));
		$title=trim(fw_strip_slashes($_POST["title"]));
		$author=trim(fw_strip_slashes($_POST["author"]));
		$description=trim(fw_strip_slashes($_POST["description"]));
		$description=str_replace("\n"," ",str_replace("\r","",$description));
		while(strpos($description,'  ')!==false){$description=str_replace('  ',' ',$description);}
		$keywords=trim(xss_cleaner(fw_strip_slashes($_POST["keywords"])));
		$keywords=str_replace("\n"," ",str_replace("\r","",$keywords));
		while(strpos($keywords,'  ')!==false){$keywords=str_replace('  ',' ',$keywords);}
		$heads=fw_strip_slashes(trim($_POST["heads"]));
		$content=fw_strip_slashes(trim($_POST["content"]));
		$indexed=empty($_POST["indexed"])? 0 : 1;
		$allowcomments=empty($_POST["allowcomments"])? 0 :1;
		$addtomenu=empty($_POST["addtomenu"])? 0 :1;
		$allowfeed=empty($_POST["allowfeed"])? 0 :1;
		$new=true;
		$dt=time();

		if($overwrite=='1'){$new=false;}
		else{
			$result = @$this->con->query(sprintf("SELECT id FROM ".PREFIX."pageinf WHERE pagename = '%s'",$this->con->real_escape_string($pagename)));
			$num_rows = @$result->num_rows;
			if(!empty($num_rows)){fw_message(true,'Error: a page of same pagename is already there!');exit;}
			$result = @$this->con->query(sprintf("SELECT id FROM ".PREFIX."postinf WHERE pagename = '%s'",$this->con->real_escape_string($pagename)));
			$row = @$result->fetch_array(MYSQL_ASSOC);
			if(!empty($row)){
				if((empty($id))||($row['id']!=$id)){echo '<script>parent.fwConfirm();</script>';exit;}
				$new=false;}
		}

		if($new){$query="INSERT INTO ".PREFIX."postinf(title, author, description, keywords, heads, content, indexed, allowcomments, addtomenu, date, updated, pagename) VALUES ('%s', '%s', '%s', '%s', '%s', '%s', $indexed, $allowcomments, $addtomenu, $dt, $dt, '%s')";}
		else{$query="UPDATE ".PREFIX."postinf SET title = '%s', author = '%s', description = '%s', keywords = '%s', heads = '%s', content = '%s', indexed = $indexed, allowcomments = $allowcomments, addtomenu = $addtomenu, updated = $dt WHERE pagename = '%s'";}
		$query=sprintf($query,$this->con->real_escape_string($title),$this->con->real_escape_string($author),$this->con->real_escape_string($description),$this->con->real_escape_string($keywords),$this->con->real_escape_string($heads),$this->con->real_escape_string($content),$this->con->real_escape_string($pagename));
		if(!$this->create_header($pagename,$headers)){fw_message(true,'Error: Unable to modify header file. Please check file permission.');exit;}
		if(!(@$this->con->query($query))){fw_message(true,$this->con->error);exit;}
		if($new){
			$id=$this->con->insert_id;
			$url=str_replace("www.","", strtolower(getenv("HTTP_HOST")));
			$identifier='tag:'.$url.','.gmdate("Y-m-d",$dt).':'.$pagename.'.html?post='.$id;
			$identifier=$this->con->real_escape_string($identifier);
			$query="INSERT INTO ".PREFIX."feed(postid, identifier, allowfeed) VALUES (".$row['id'].", '$identifier', $allowfeed)";
			@$this->con->query($query);
			echo '<script>parent.location.href="index.php?qur=2M1M'.$id.'";</script>';exit;}
		else{
			$query=sprintf("UPDATE ".PREFIX."feed SET allowfeed = $allowfeed WHERE postid = %u",$id);
			@$this->con->query($query);
			fw_message(false,'Data has been suscessfully updated.');}
		exit;
}
public function get_query($query='')
{
if ($this->validate_user()){
    switch ($query[1]) {
        case "6":
            $this->show_list($query[2]);
        break;
        case "7":
            $this->edit_post($query[2], $query[3]);
        break;
        case "1":
            $this->show_edit($query[2]);
        break;
        case "2":
            $this->delete_page($query[2]);
        break;
        case "3":
            $this->publish_post($query[2]);
        break;
        case "4":
            $this->show_fw_preview();
        break;
        case "5":
            $this->log_out();
        break;
        default :
            $this->show_list(1);
    }
}
else{if(($query[1]!='4')||($query[1]!='7')){$this->log_in();}}
}
private function show_list($page)
{
		$search='';
        $sortDir='Desc';
        $sortCol='id';
        if(!empty($_GET['sortCol'])){$sortCol=fw_strip_slashes($_GET['sortCol']);}
        if(!empty($_GET['sortDir'])){$sortDir=fw_strip_slashes($_GET['sortDir']);}
        if(!empty($_GET['SearchFileString'])){$search=fw_strip_slashes($_GET['SearchFileString']);}
        $this->build_head("Post list",'', '');
        $result = @$this->con->query(sprintf("SELECT id FROM ".PREFIX."postinf WHERE pagename LIKE '%%%s%%'",$this->con->real_escape_string($search)));
        $num_rows = @$result->num_rows;
        $start_count=($page-1)*$this->list_perpage;
        $totalpage=fw_total_page($num_rows, $this->list_perpage);

        echo '<table id="list"><tr><td class="heading" style="width:60%;"><a href="index.php?qur=2M6M1&SearchFileString='.$search.'&sortCol=pagename&sortDir=Asc"><img src="images/up.gif" onmouseover="this.src=\'images/uph.gif\'" onmouseout="this.src=\'images/up.gif\'" /></a><a href="index.php?qur=2M6M1&SearchFileString='.$search.'&sortCol=pagename&sortDir=Desc"><img src="images/dn.gif" onmouseover="this.src=\'images/dnh.gif\'" onmouseout="this.src=\'images/dn.gif\'" /></a><b>File name</b></td>';
        echo '<td class="heading" style="width:10%;">Comments</td><td class="heading"></td>';
		echo '<td class="heading"><a href="index.php?qur=2M6M1&SearchFileString='.$search.'&sortCol=updated&sortDir=Asc"><img src="images/up.gif" onmouseover="this.src=\'images/uph.gif\'" onmouseout="this.src=\'images/up.gif\'" /></a><a href="index.php?qur=2M6M1&SearchFileString='.$search.'&sortCol=updated&sortDir=Desc"><img src="images/dn.gif" onmouseover="this.src=\'images/dnh.gif\'" onmouseout="this.src=\'images/dn.gif\'" /></a><b>Last modified</b></td></tr>';
        echo '<tr><td colspan="4"><big>*</big>&nbsp;<a href="index.php?qur=2M1M">Create new</a></td></tr>';
        $query="SELECT tp.id, tp.pagename, tp.title, tp.updated, tp.publish, tp.allowcomments, IF(ISNULL(tc.id), 0,COUNT(tc.id)) AS c FROM ".PREFIX."postinf tp LEFT JOIN ".PREFIX."comments tc ON tp.id = tc.pid WHERE ";
		$query.="tp.pagename LIKE '%%%s%%' GROUP BY tp.id ORDER BY $sortCol $sortDir LIMIT ".$start_count.", ".$this->list_perpage;
		$query=sprintf($query,$this->con->real_escape_string($search));
        $result = @$this->con->query($query);
        while($row = @$result->fetch_array(MYSQL_ASSOC))
        {
            echo '<tr onMouseOver="this.className=\'highlight\'" onMouseOut="this.className=\'normal\'">';
			$src='<img title="Published" src="images/approved.gif" alt="P" />';$color='#133d62';
			if(empty($row['title'])){$src='<img title="No title" src="images/notitle.gif" alt="T" />';$color='#b37044';}
			if(!$row['publish']){$src='<img title="Unpublished" src="images/unpublished.gif" alt="U" />';$color='#f40104';}
            echo '<td>'.$src;
            echo '<a style="color:'.$color.'" href="index.php?qur=2M1M'.$row['id'].'">'.$row['pagename'];
            echo '</a></td>';
			echo '<td style="text-align:center;">';
			if($row['allowcomments']){echo ((empty($row['c']))? 'Comment(0)' : '<a href="index.php?qur=9M6M1M'.$row['id'].'M0">Comment('.$row['c'].')</a>');}
			else{echo ((empty($row['c']))? 'Locked' : '<a href="index.php?qur=9M6M1M'.$row['id'].'M0">Locked('.$row['c'].')</a>');}
			echo '</td>';
			echo '<td style="text-align:center;">';
			echo ((($row['publish'])&&!empty($row['title']))? '<a href="'.BLOG_URL.$row['pagename'].'.html" target="_blank">View</a>' : 'View');
			echo ' | <a href="javascript:fw_openEditor('.$row['id'].',2)">Edit</a> | <a href="javascript:fwPagestatDetail(\''.addslashes($row['pagename']).'\')">Stat</a></td>';
            echo '<td>'.gmdate("M d, Y, H:i", $row['updated']).'</td></tr>';
        }

        echo '<tr><td colspan="4"><b>No. of pages:&nbsp;'.$totalpage.'</b>&nbsp;&nbsp;&nbsp;';

        $start=(($page>10)? $page-10 : 1);
        $end=(($totalpage<=21)? $totalpage : $start+20);
        echo(($page>1)? '<a href="index.php?qur=2M6M'.($page-1).'&SearchFileString='.$search.'&sortCol='.$sortCol.'&sortDir='.$sortDir.'">Back</a>&nbsp;' : '<span style="color:#808080;">Back</span>&nbsp;');
        for($p=$start; $p<=$end; $p++){
             if($p==$page){echo '<span style="color:#808080;">['.$p.']</span>&nbsp;';}
             else{echo '[<a href="index.php?qur=2M6M'.$p.'&SearchFileString='.$search.'&sortCol='.$sortCol.'&sortDir='.$sortDir.'">'.$p.'</a>]&nbsp;';}
        }
        echo(($page<$totalpage)? '<a href="index.php?qur=2M6M'.($page+1).'&SearchFileString='.$search.'&sortCol='.$sortCol.'&sortDir='.$sortDir.'">Next</a>&nbsp;' : '<span style="color:#808080;">Next</span>&nbsp;');

        echo '</td></tr>';
        echo '<tr><td colspan="4" style="background:#e0e0e0;text-align:right;">';
        echo '<form name="frmSearchList" style="margin:0; color:#000000;" onSubmit="return fw_search(\'index.php?qur=2M6M1\');">';
        echo 'Search file:&nbsp;<input name="txtSearch" style="padding-left:5px; width:180px; font-size:11px; color:#666666;" type="text" value="';
        echo (($search=='')? 'Type first few characters...' : $search);
        echo '" size="20" onClick="fw_cleartext(this);">&nbsp;<input name="Submit" type="button" style="width:80px; font-size:11px; color:#333333;" value="Search" onClick="fw_search(\'index.php?qur=2M6M1\');"></form></td></tr></table>';
        echo '</div>';
        $this->build_footer();
}
private function publish_post($id)
{
        $query=sprintf("SELECT publish FROM ".PREFIX."postinf WHERE id = %u",$id);
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
		if($row['publish']){$publish=0;$response='Publish';}
		else{$publish=1;$response='Block';}
        $query=sprintf("UPDATE ".PREFIX."postinf SET publish = $publish WHERE id = %u",$id);
        if(@$this->con->query($query)){echo '<script>parent.document.getElementById("publish").innerHTML="'.$response.'";</script>';}
		else{fw_message(true,$this->con->error);}
		exit;
}
private function delete_page($id)
{
		$query=sprintf("SELECT pagename FROM ".PREFIX."postinf WHERE id = %u",$id);
		$result = @$this->con->query($query);
		$row = @$result->fetch_array(MYSQL_ASSOC);
		$pagename=$row['pagename'];
		$header='../headers/'.str_replace('/','.',$pagename).'.php';
		if(file_exists($header)){@unlink($header);}
		$query = sprintf("DELETE tp, tc FROM ".PREFIX."postinf tp LEFT JOIN ".PREFIX."comments tc ON tc.pid = tp.id WHERE tp.id = %d",$id);
		if(@$this->con->query($query)){echo '<script>parent.location.href="index.php?qur=2M";</script>';}
		else{fw_message(true,$this->con->error);}
		exit;
}
}
?>