<?php
/*
Copyright (c) 2008 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
include "../../include/functions.php";
class install
{
private $con;
private function install_now()
{
		$dbname=fw_strip_slashes(trim($_POST['dbname']));
		$dbuser=fw_strip_slashes(trim($_POST['dbuser']));
		$dbpw=fw_strip_slashes(trim($_POST['dbpw']));
		$savedpw=fw_strip_slashes(trim($_POST['password']));
		$pw=md5($savedpw);
		$author=fw_strip_slashes(trim($_POST['author']));
		$admin=fw_strip_slashes(trim($_POST['admin']));
		$email=fw_strip_slashes(trim($_POST['email']));
		$prefix=fw_strip_slashes(trim($_POST['prefix']));
		$dt=time();
		if(!(empty($_POST['dbhost']))){$dbhost=fw_strip_slashes(trim($_POST['dbhost']));}
		else{$dbhost='localhost';}
		$this->con=@new mysqli($dbhost,$dbuser,$dbpw,$dbname);
		if(mysqli_connect_errno()){fw_message(true,mysqli_connect_error());exit;}
		if(version_compare(phpversion(),'5.2.1')===-1){fw_message(true,'Inadequate system: PHP version requirement is 5.2.1 or higher. Your server php version is '.phpversion().'<br />Please contact with your hosting provider.');exit;}
		$ve=$this->con->server_version/10000;
		if($ve<5){fw_message(true,'Inadequate system: MYSQL version requirement is 5.0 or higher. Your MYSQL server version is '.$ve.'<br />Please contact with your hosting provider.');exit;}
		$result=$this->con->query("SHOW TABLES LIKE \"$prefix%\"");
		if($result->num_rows){fw_message(true,'Table already exist. Please use different table prefix.');exit;}

		$filename="../../database/config.php";
		$handle=@fopen($filename,'w');
		if (!(@fwrite($handle,"<?php\n"))){
			@fclose($handle);
			fw_message(true,'Error in file permission Please set chmod to &quot;777&quot; or &quot;0777&quot; of the file &quot;admin/database/config.php&quot;. Start installation again.');exit;
		}
		fwrite($handle,'$dbhost=');
		fwrite($handle,"'$dbhost';\n");
		fwrite($handle,'$dbuser=');
		fwrite($handle,"'$dbuser';\n");
		fwrite($handle,'$dbpw=');
		fwrite($handle,"'$dbpw';\n");
		fwrite($handle,'$dbname=');
		fwrite($handle,"'$dbname';\n");
		fwrite($handle,"define('PREFIX','$prefix');\n?>");
		fclose($handle);

		$selfurl = str_replace("www.","", strtolower(getenv("HTTP_HOST")));
		$str=file("query.txt");
		$symbals=array('prefix_','__SELFURL__','__DATE__','__EMAIL__','__AUTHOR__');
		$replacements=array($prefix,$selfurl,$dt,$email,$author);
		for($i=0; $i<count($str); $i++){
			$query=str_replace($symbals,$replacements,trim($str[$i]));
			$result = @$this->con->query($query);
			if(!($result)){$this->clear_install($prefix);fw_message(true,"Error executing query string => ".($i+1));exit;}
		}
		unset($symbals,$replacements);
		$query = sprintf("INSERT INTO ".$prefix."admin (user, password, email) VALUES ('%s', '%s', '%s')",$this->con->real_escape_string($admin),$this->con->real_escape_string($pw),$this->con->real_escape_string($email));
		$result = @$this->con->query($query);
		if(!($result)){$this->clear_install($prefix);fw_message(true,$this->con->error);exit;}

		//Update feed
		$tag='tag:'.$selfurl.','.date("Y-m-d",$dt).':';
		$query="INSERT INTO ".$prefix."feed(postid, identifier) VALUES (1, '".$tag."index.html'), (2, '".$tag."about.html?post=2'), (3, '".$tag."terms-of-use.html?post=3')";
		@$this->con->query($query);

		//Confirmation
		$from='contact@ramui.com';
		$subject='Ramui webblog has been successfully installed';
		$headers="From: ".$from."\r\n";
		$message="Congratulations! Your ramui webblog version-5 has been successfully installed.\r\n\r\nLogin information:\r\n------------------------------------------\r\n";
		$message.="User name: $admin";
		$message.="\r\nPassword: $savedpw";
		$message.="\r\nLogin url: http://".getenv('HTTP_HOST').DOCROOT."fw_blog/admin/index.php";
		$message.="\r\n------------------------------------------\r\n\r\nThank you.\r\nArchan Ghosal.(http://ramui.com)";
		@mail($email,$subject,$message,$headers);

		$str="<html><head><title>Installation form</title>";
		$str.="<style>body{background:#cee7ff;font:500 12px tahoma;}div{margin:20px;padding:10px;border:1px solid #5284ce;background:#ffffff;text-align:left;width:600px;}td{font:500 12px tahoma;padding:3px;border:1px solid #c0c0c0;}h1{font:500 18px tahoma;color:#333333;}</style>";
		$str.="</head><body><center><div><h1>Ramui webblog has been successfully installed</h1><table><tr><td>Database name:</td><td>$dbname</td></tr><tr><td>Database user name:</td><td>$dbuser</td></tr><tr><td>Database password:</td><td>$dbpw</td></tr><tr><td>Database host name:</td><td>$dbhost</td></tr><tr><td>Table prefix:</td><td>$prefix</td></tr><tr><td>User name:</td><td>$admin</td></tr><tr><td>Password:</td><td>$savedpw</td></tr><tr><td>Email address:</td><td>$email</td></tr></table><hr/><p style='color:#808080;font-size:10px;'>**Please keep a hard copy of this document.</p></div></center></body></html>";
		$str=str_replace('<','&lt;',str_replace('>','&gt;',$str));
		$x='<form method="post" name="frmdownload" action="index.php" target="formSubmit"><input name="txtdownload" type="hidden" value="'.$str.'" /><h1>Ramui webblog has been successfully installed</h1><p>Your Ramui webblog version-5 has been successfully installed. An email has been sent to your email address describing all detail about installation.</p>';
		$x.='<ul><li>Please <a href="'.$self_path.'">click here</a> to login to your control panel</li>';
		$x.='<li>Please click the button below to keep a copy of the data you provide in installation form for future reference.</li></ul><p><input name="btndownload" type="submit" value="Download Installation Data" /></p><div id="footer"><small>';
		$x.='ramui webblog &copy;&nbsp<a target="_blank" href="http://ramui.com">http://ramui.com</a>. All rights reserved.</small></div></form>';
		echo '<script>parent.document.getElementById("success").innerHTML="'.addslashes($x).'";</script>';exit;
}

private function build_head($title, $script)
{
		include "../include/head.php";
}

private function build_footer()
{
		include "../include/footer.html";
		exit;
}

public function get_install()
{
		if(!empty($_POST['btndownload'])){
			$str=fw_strip_slashes(trim($_POST['txtdownload']));
			@header("Content-type: application/text");
			@header("Content-Disposition: attachment; filename=Installation_form.html");
			echo $str;
		}
		elseif(filesize("../../database/config.php")>10){
			$self_path=BLOG_URL.'fw_blog/admin/index.php';
			@header("Location: $self_path");}
		elseif(!((empty($_POST['dbname']))||(empty($_POST['dbuser']))||(empty($_POST['dbpw'])))){
			$this->install_now();}
		else{include "frminstall.php";}
		exit;
}

private function clear_install($prefix)
{
		$query='DROP TABLE IF EXISTS '.$prefix.'admin, '.$prefix.'user, '.$prefix.'comments, '.$prefix.'pageinf, '.$prefix.'postinf, '.$prefix.'settings, '.$prefix.'addonpage, '.$prefix.'inbox, '.$prefix.'webstat, '.$prefix.'mailsettings, '.$prefix.'preview, '.$prefix.'keywords, '.$prefix.'feed, '.$prefix.'menu';
		@$this->con->query($query);
		$filename="../../database/config.php";
		@file_put_contents($filename,'');
}
}
$obj=new install();
$obj->get_install();
?>