<?php
/*
Copyright (c) 2008 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
define('DOCROOT', str_replace('fw_blog/include/functions.php','',str_replace($_SERVER['DOCUMENT_ROOT'],'',str_replace('\\','/',__FILE__))));
define('UPLOAD_URL','http://'.getenv('HTTP_HOST').DOCROOT.'fw_blog/upload/');
define('UPLOAD_PATH',$_SERVER['DOCUMENT_ROOT'].DOCROOT.'fw_blog/upload/');
define('BLOG_URL','http://'.getenv('HTTP_HOST').DOCROOT);
function fw_strip_slashes($str)
{
        return get_magic_quotes_gpc()? stripslashes($str):$str;
}
function fw_total_page($c, $p)
{
        if ($c<1){ return 0;}
        $d=$c;
        for ($i=1; $i<=$c; $i++){
            $d=$d-$p;
            if ($d<=0){ return $i;}
        }
}
function fw_preview($s)
{
        $str=str_replace("\n", ' ', $s);
        $str=str_replace("\r", '', $str);
        $str=substr($str, 0, 127).'...';
        return $str;
}
function fw_abs_to_url($abs_path)
{
         return 'http://'.str_replace($_SERVER['DOCUMENT_ROOT'], $_SERVER['HTTP_HOST'],$abs_path);
}
function fw_random()
{
		return substr(str_shuffle('abcdefghijklmnopqrstuvwxyz_0123456789'),0,rand(8,16));
}

function fw_get_querydata($q,$url='')
{
        if($url==''){$url='http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];}
		$qur=parse_url($url,PHP_URL_QUERY);
		parse_str($qur,$arr);
		return (isset($arr[$q])? $arr[$q]:'');
}
function fw_get_currentpagecontent($str,$page)
{
		$start=0;
		for($i=1;$i<$page;$i++){
			if(($start=strpos($str,'<fw_pagebreak />',$start))===false){break;}
			$start=$start+16;
		}
		$str=substr($str,$start);
		return ((($pos=strpos($str,'<fw_pagebreak />'))===false)? $str : substr($str,0,$pos));
}
function fw_validate_pagename($name)
{
		if(preg_match('/^([a-zA-Z0-9\/\ \:_\-]){1,250}$/',$name)){
			$arr=explode('/',$name);
			foreach($arr as $a){if(!((preg_match('/^([a-zA-Z0-9])/',$a))&&(preg_match('/([a-zA-Z0-9])$/',$a)))){return false;}}
			return true;
		}
		return false;
}
function fw_validate_user($name,$email)
{
		return ((preg_match('/^([a-zA-Z0-9]){5,16}$/',$name))&&(fw_validate_email($email)));
}
function fw_validate_email($email)
{
		return preg_match('/^([a-zA-Z0-9\-\._@]){7,110}$/',$email);
}
function fw_php2javascript($text)
{
		return str_replace("\r",'\r',str_replace("\n",'\n',addslashes($text)));
}
function fw_error($msg)
{
		return '<script>parent.document.getElementById("feedback").innerHTML="<span style=\"color:red; background:#ffffff;\">'.fw_php2javascript($msg).'</span>";</script>';
}
function fw_message($err,$msg)
{
		echo '<script>parent.document.getElementById("feedback").innerHTML="<span style=\"color:'.(($err)? 'red':'green').'; background:#fff;\">'.fw_php2javascript($msg).'</span>";</script>';
}
function fw_get_pagename()
{
		if((substr($_SERVER['SCRIPT_NAME'], strlen(DOCROOT)))!=='index.php'){exit;}
        $pagename=isset($_GET['fw_postname'])? htmlspecialchars(fw_strip_slashes(@$_GET['fw_postname'])):'index';
        if((strpos($pagename,'fw_blog/')===0)||(!fw_validate_pagename($pagename))){include str_replace('/clsdatabase.php','/errormessage.php',str_replace('\\','/',__FILE__)); exit;}
		return $pagename;
}
function xss_cleaner($str)
{
		$str = str_replace( array('&','<','>',"'",'"',')','('), array('&amp;','&lt;','&gt;','&apos;','&#x22;','&#x29;','&#x28;'), $str );
		return str_ireplace( '%3Cscript', '', $str );
}
function verify_url(&$url)
{
		$arr=parse_url($url);
		if(($arr===false)||(empty($arr['host']))){return false;}
		$arr['host']=strtolower($arr['host']);
		$scheme=empty($arr['scheme'])? 'http' : strtolower($arr['scheme']);
		$url=$scheme.'://'.$arr['host'].'/';
		return true;
}

?>