<?php
/*
Copyright (c) 2008 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class comments extends clsmain
{
private function show_edit($comment_number)
{
        $query="SELECT tc.*, tu.user, tp.pagename FROM ".PREFIX."comments tc LEFT JOIN ".PREFIX."user tu ON tc.uid = tu.id ";
		$query.="LEFT JOIN ".PREFIX."postinf tp ON tc.pid = tp.id WHERE tc.id = %u";
		$query=sprintf($query,$comment_number);
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
		$menu='<li><a href="index.php?qur=9M">comments</a></li><li><a href="javascript:fwDelete('.$comment_number.')">Delete</a></li><li><a href="javascript:fwPublish('.$comment_number.')"><span id="publish">'.(($row['publish'])? 'Block' : 'Publish').'</span></a></li>';
		$this->build_head("Comment".$comment_number,'<script type="text/javascript" src="script/comment.js"></script><script type="text/javascript" src="../bbcode/bbcode.js"></script>',$menu);
		$commentsize=$this->site['commentsize'];
		$action='index.php?qur=9M4M'.$comment_number;
        include 'include/editcomments.php';
        $this->build_footer();
}
public function get_query($query='')
{
if ($this->validate_user()){
      switch ($query[1]) {
          case "1":
              $this->show_edit($query[2]);
          break;
          case "2":
              $this->delete_comment($query[2]);
          break;
          case "3":
              $this->publish_comment($query[2]);
          break;
          case "4":
              $this->edit_comment($query[2]);
          break;
          case "5":
              $this->log_out();
          break;
          case "6":
              $this->show_commentlist($query[2],$query[3],$query[4]);
          break;
          default :
              $this->show_commentlist(1,0,0);
      }
}
else {if($query[1]!="4"){$this->log_in();}}
}

private function delete_comment($id)
{
		$query = sprintf("DELETE FROM ".PREFIX."comments  WHERE id = %u",$id);
		if(@$this->con->query($query)){echo '<script>parent.location.href="index.php?qur=9M";</script>';}
		else{fw_message(false,$this->con->error);}
		exit;
}
private function publish_comment($comment_number)
{
        $query=sprintf("SELECT publish FROM ".PREFIX."comments WHERE id = %u",$comment_number);
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
        if($row['publish']){$publish=0;$response='Publish';}
		else{$publish=1;$response='Block';}
        $query=sprintf("UPDATE ".PREFIX."comments SET publish = $publish WHERE id = %u",$comment_number);
        if(@$this->con->query($query)){echo $response;}exit;
}

private function edit_comment($comment_number)
{
        $title=trim(fw_strip_slashes($_POST["title"]));
        $comment=xss_cleaner(trim(fw_strip_slashes($_POST["fw_editor"])));
		if(strlen($comment)>$this->site['commentsize']){echo '<script>parent.document.getElementById("feedback").innerHTML="<span style=\"color:red; background:#ffffff;\">Error! Max. comment size is '.$this->site['commentsize'].' characters.</span>";</script>';exit;}
        $query=sprintf("UPDATE ".PREFIX."comments SET title = '%s', comment = '%s' WHERE id = %u",$this->con->real_escape_string($title),$this->con->real_escape_string($comment),$comment_number);
        if(!(@$this->con->query($query))){echo '<script>parent.document.getElementById("feedback").innerHTML="<span style=\"color:red; background:#ffffff;\">Unable to update comment at this moment.</span>";</script>';}
        else{fw_message(false,'Update change successfully.');}
		exit;
}
private function show_commentlist($page,$pid,$uid)
{
        $search='';
        $sortDir='Desc';
        $sortCol='date';
        if(!empty($_GET['sortCol'])){$sortCol=fw_strip_slashes($_GET['sortCol']);}
        if(!empty($_GET['sortDir'])){$sortDir=fw_strip_slashes($_GET['sortDir']);}
        if(!empty($_GET['SearchFileString'])){$search=fw_strip_slashes($_GET['SearchFileString']);}
        $this->build_head("Comment list", '','');
		$query=sprintf("SELECT id FROM ".PREFIX."comments WHERE title LIKE '%%%s%%'",$this->con->real_escape_string($search));
		if(!empty($uid)){$query.=sprintf(" AND uid = %u",$uid);}
		if(!empty($pid)){$query.=sprintf(" AND pid = %u",$pid);}
        $result = @$this->con->query($query);
        $num_rows = @$result->num_rows;
        $start_count=($page-1)*$this->list_perpage;
        $totalpage=fw_total_page($num_rows, $this->list_perpage);

        echo '<div style="width:100%; overflow-x:scroll;"><table id="list"><tr><td class="heading" style="width:70%;"><a href="index.php?qur=9M6M1M'.$pid.'M'.$uid.'&SearchFileString='.$search.'&sortCol=title&sortDir=Asc"><img src="images/up.gif" onmouseover="this.src=\'images/uph.gif\'" onmouseout="this.src=\'images/up.gif\'" /></a><a href="index.php?qur=9M6M1M'.$pid.'M'.$uid.'&SearchFileString='.$search.'&sortCol=title&sortDir=Desc"><img src="images/dn.gif" onmouseover="this.src=\'images/dnh.gif\'" onmouseout="this.src=\'images/dn.gif\'" /></a>Title</td>';
        echo '<td class="heading" style="width:9%;text-align:center;">User</td><td class="heading">Post</td>';
		echo '<td class="heading" style="border-right:none;"><a href="index.php?qur=9M6M1M'.$pid.'M'.$uid.'&SearchFileString='.$search.'&sortCol=date&sortDir=Asc"><img src="images/up.gif" onmouseover="this.src=\'images/uph.gif\'" onmouseout="this.src=\'images/up.gif\'" /></a><a href="index.php?qur=9M6M1M'.$pid.'M'.$uid.'&SearchFileString='.$search.'&sortCol=date&sortDir=Desc"><img src="images/dn.gif" onmouseover="this.src=\'images/dnh.gif\'" onmouseout="this.src=\'images/dn.gif\'" /></a><b>Last modified</b></td></tr>';
        echo '<tr><td colspan="4"><big>*</big>&nbsp;<a title="Remove filter" href="index.php?qur=9M6M1M0M0">Comment list</a></td></tr>';
        $query="SELECT tc.id, tc.title, tc.uid, tc.pid, tc.date, tc.publish, tu.user, tp.publish AS pub, tp.pagename AS postname FROM ".PREFIX."comments tc LEFT JOIN ".PREFIX."user tu ON tc.uid = tu.id LEFT JOIN ".PREFIX."postinf tp ON tc.pid = tp.id WHERE tc.title LIKE '%%%s%%'";
		$query=sprintf($query,$this->con->real_escape_string($search));
		if(!empty($uid)){$query.=sprintf(" AND tc.uid = %u",$uid);}
		if(!empty($pid)){$query.=sprintf(" AND tc.pid = %u",$pid);}
		$query.=" GROUP BY tc.id ORDER BY $sortCol $sortDir LIMIT ".$start_count.", ".$this->list_perpage;
        $result = @$this->con->query($query);
        while($row = @$result->fetch_array(MYSQL_ASSOC))
        {
            echo '<tr onMouseOver="this.className=\'highlight\'" onMouseOut="this.className=\'normal\'">';
			$src='<img title="Published" src="images/approved.gif" alt="P" />';
			if(!$row['publish']){$src='<img title="Unpublished" src="images/unpublished.gif" alt="U" />';}
            echo '<td>'.$src;
            echo '<a href="index.php?qur=9M1M'.$row['id'].'">'.(empty($row['title'])? 'No title':$row['title']).'</a></td>';
			echo '<td style="text-align:center;"><a href="index.php?qur=6M7M'.$row['uid'].'">'.$row['user'].'</a></td>';
			echo '<td style="text-align:center;">'.((($row['pub'])&&($row['publish']))? '<a target="_blank" href="http://'.getenv('HTTP_HOST').DOCROOT.$row['postname'].'.html">View</a>' : '<span style="color:#888888; font-family:tahoma;">View</span>').'</td>';
            echo '<td>'.gmdate("M d, H:i", $row['date']).'</td></tr>';
        }

        echo '<tr><td colspan="4"><b>No. of pages:&nbsp;'.$totalpage.'</b>&nbsp;&nbsp;&nbsp;';

        $start=(($page>10)? $page-10 : 1);
        $end=(($totalpage<=21)? $totalpage : $start+20);
        echo(($page>1)? '<a href="index.php?qur=9M6M'.($page-1).'M'.$pid.'M'.$uid.'&SearchFileString='.$search.'&sortCol='.$sortCol.'&sortDir='.$sortDir.'">Back</a>&nbsp;' : '<span style="color:#808080;">Back</span>&nbsp;');
        for($p=$start; $p<=$end; $p++){
             if($p==$page){echo '<span style="color:#808080;">['.$p.']</span>&nbsp;';}
             else{echo '[<a href="index.php?qur=9M6M'.$p.'M'.$pid.'M'.$uid.'&SearchFileString='.$search.'&sortCol='.$sortCol.'&sortDir='.$sortDir.'">'.$p.'</a>]&nbsp;';}
        }
        echo(($page<$totalpage)? '<a href="index.php?qur=9M6M'.($page+1).'M'.$pid.'M'.$uid.'&SearchFileString='.$search.'&sortCol='.$sortCol.'&sortDir='.$sortDir.'">Next</a>&nbsp;' : '<span style="color:#808080;">Next</span>&nbsp;');

        echo '</td></tr>';
        echo '<tr><td colspan="4" style="background:#e0e0e0; padding-bottom:0;">';
        echo '<form name="frmSearchList" style="float:right; margin:0; color:#000000;" onSubmit="return fw_search(\'index.php?qur=9M6M1M0M0\');">';
        echo 'Search file:&nbsp;<input name="txtSearch" style="padding-left:5px; width:180px; font-size:11px; color:#666666;" type="text" value="';
        echo (($search=='')? 'Type first few characters...' : $search);
        echo '" size="20" onClick="fw_cleartext(this);">&nbsp;<input name="Submit" type="button" style="width:80px; font-size:11px; color:#333333;" value="Search" onClick="fw_search(\'index.php?qur=9M6M1M0M0\');"></form></td></tr></table></div>';
        echo '</div>';
        $this->build_footer();
}
}
?>