<?php
/*
Copyright (c) 2008 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class language extends clsmain
{
function __construct()
{
		parent::__construct();
		define('LANGUAGE_PATH',$_SERVER['DOCUMENT_ROOT'].DOCROOT.'fw_blog/languages/');
}
private function show_uploadlist()
{
		$caption=substr(LANGUAGE_PATH,1,-1);
        $this->build_head($caption, '<script type="text/javascript" src="script/language.js"></script>','');
        echo '<iframe name="formSubmit" id="formSubmit" style="display:none;"></iframe><table class="detail" style="width:100%; margin:0 0 10px 0;">';
        echo '<tr><td colspan="2" style="background:#e0e0e0;padding:5px;border-bottom:1px solid #c0c0c0;"><b>Languages:</b></td></tr>';
        echo '<tr><td colspan="2"><img title="Install default" src="images/restore.gif" /><a href="#" onclick="return fwInstallDefault()">Restore default</a></td></tr>';
        $dirs='';
		$files='';
		if($handle=opendir(LANGUAGE_PATH)){
			while (false !== ($item = readdir($handle))){if($item != "." && $item != ".."){
				if(is_dir(LANGUAGE_PATH.$item)){
					$dirs.='<tr onMouseOver="this.className=\'highlight\'" onMouseOut="this.className=\'normal\'"><td><img src="images/edit.gif"/><a href="index.php?qur=11M3&dir='.$item.'">'.$item.'</a></td><td style="text-align:center">';
					$dirs.='<a href="#" onclick="return fwDownload(\''.$item.'\')">Download</a> | ';
					$dirs.='<a style="color:#339955;" href="#" onclick="return fwInstall(\''.$item.'\');">Install</a> | ';
					$dirs.='<a style="color:#993322;" href="#" onclick="return fwDelete(\''.$item.'\');">Delete</a></td></tr>';
				}
			}}
			closedir($handle);
		}
		echo $dirs.'<tr onMouseOver="this.className=\'highlight\'" onMouseOut="this.className=\'normal\'"><td colspan="2"><img src="images/keys.png"/><a href="#" onclick="return fwOpenKey()">Keys</a>'.'</td></tr>';
		echo '<tr><td colspan="2" style="background:#e0e0e0;">';
        echo '<form name="frmNew" action="index.php?qur=11M6" method="POST" target="formSubmit" style="float:right; margin:0; color:#000000;" onSubmit="return fwCreateNew();">';
        echo '<img title="Create new language" src="images/new_lan.gif" />Create new file: <input name="name" type="text" style="padding-left:5px; width:180px; font-size:11px; color:#666666;"/>&nbsp;&nbsp;<input name="submit" type="submit" value="Create file" style="width:80px; font-size:11px; color:#333333;"/>&nbsp;<input type="reset" value="Reset" style="width:80px; font-size:11px; color:#333333;"></form>';
        echo '</td></tr>';
        echo '</table><div id="feedback" style="margin:0;padding:0;"></div></div>';
        $this->build_footer();
}
private function show_edit()
{
		$filename=trim($_GET['dir']);
		if(is_dir(LANGUAGE_PATH.$filename)){$content=@file_get_contents(LANGUAGE_PATH.$filename.'/value.txt');}
		else{$filename=false;}
		$hmenu='<li><a href="index.php?qur=11M">File list</a></li><li><a target="_blank" href="http://translate.google.com/">Google translate</a></li>';
		$this->build_head('Edit anguage: '.$filename,'',$hmenu);
		include "include/editlanguage.php";
		$this->build_footer();
}
private function download()
{
		$name=fw_strip_slashes($_GET['file']);
		$filename=LANGUAGE_PATH.$name.'/value.txt';
		$name.='.txt';
		$str=@file_get_contents($filename);
		@header("Content-type: application/text");
		@header("Content-Disposition: attachment; filename=$name");
		echo $str;exit;
}
private function install()
{
		$filename=isset($_GET['dir'])? (LANGUAGE_PATH.(urldecode($_GET['dir'])).'/value.txt'):LANGUAGE_PATH.'.default.txt';
		$keys=file(LANGUAGE_PATH.'key1.txt',FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
		$values=file($filename,FILE_IGNORE_NEW_LINES);
		$c=count($keys);
		$lan="<?php\r\n";
		for($i=0; $i<$c; $i++){$lan.="define('".addslashes($keys[$i])."','".addslashes($values[$i])."');\r\n";}
		$lan.="?>";
		if(!@file_put_contents($_SERVER['DOCUMENT_ROOT'].DOCROOT.'fw_blog/database/language1.php',$lan)){fw_message(true,'Unespected error! Please contact program vendor.');exit;}
		$keys=file(LANGUAGE_PATH.'key2.txt',FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
		$c2=count($keys);
		$lan="<?php\r\n";
		for($i=0; $i<$c2; $i++){$lan.="define('".addslashes($keys[$i])."','".addslashes($values[$c+$i])."');\r\n";}
		$lan.="?>";
		if(!@file_put_contents($_SERVER['DOCUMENT_ROOT'].DOCROOT.'fw_blog/database/language2.php',$lan)){fw_message(true,'Unespected error! Please contact program vendor.');exit;}
		fw_message(false,'Language has been successfully installed.');
		unset($keys,$values);
		exit;
}
private function delete_file()
{
        $filename=LANGUAGE_PATH.fw_strip_slashes(urldecode($_GET['source']));
		if(!is_dir($filename)){fw_message(true,'Source not found!');exit;}
		if(@unlink($filename.'/value.txt')){if(rmdir($filename)){fw_message(false,'File is successfully deleted!');exit;}}
		fw_message(true,'Sorry! Unable to delete file. Please check file permission.');exit;
}
private function create_new()
{
        $name=strtolower(fw_strip_slashes($_POST['name']));
		if(!preg_match('/^([a-z0-9]){3,20}$/',$name)){echo '<script>alert("Invalid language file name!");</script>';exit;}
		$name=LANGUAGE_PATH.$name;
		if(is_dir($name)){echo '<script>alert("Sorry! Language file already exist.");</script>';exit;}
		if(mkdir($name)){
			if(copy(LANGUAGE_PATH.'.default.txt',$name.'/value.txt')){echo '<script>parent.location.href="index.php?qur=11M";</script>';exit;}
			else{@rmdir($name);}
		}
		echo '<script>alert("Sorry! unable to create language file!\nPlease check file permission.");</script>';
}
private function save_edit()
{
        $filename=trim(fw_strip_slashes($_POST["filename"]));
        $content=trim(fw_strip_slashes($_POST["content"]));
		if(!is_dir(LANGUAGE_PATH.$filename)){echo '<script>parent.location.href="index.php?qur=11M";</script>';exit;}
        $f=LANGUAGE_PATH.$filename.'/value.txt';
		$handle=@fopen($f,'w');
		if(!$handle){echo fw_message(true,'Sorry! unable to update language file! Please check file permission.');exit;}
		fwrite($handle,$content);
		fclose($handle);
		fw_message(false,'File has been updated.');exit;
}

private function show_key()
{
        $filename=LANGUAGE_PATH.'key1.txt';
		$content=nl2br(file_get_contents($filename));
        $filename=LANGUAGE_PATH.'key2.txt';
		$content.='<br />'.nl2br(file_get_contents($filename));
        $str='<html><head><title>Language keys:</title>';
        $str.='<style>
        <!--
        body{font-family:\'courier new\'; font-size:12px;line-height:130%;padding:0;margin:0;}
		#content{clear:both;margin:20px 5px 5px 5px;padding:5px;border:1px solid #aaaaaa;font-family:\'courier new\'; font-size:14px;line-height:130%;}
        -->
        </style></head>
        <body>
		<div style="background:url(\'images/popup.gif\') repeat-x;clear:both;border-bottom:1px solid #808080;margin:0;padding:10px;text-align:right;"><a href="javascript:window.close()">Close this window</a></div>
        <div id="content">'.$content.'</div></body></html>';
        echo $str;
}
public function get_query($query='')
{
if ($this->validate_user()){
    switch ($query[1]) {
        case "1":
            $this->show_uploadlist();
        break;
        case "2":
            $this->delete_file();
        break;
        case "3":
            $this->show_edit();
        break;
        case "4":
            $this->save_edit();
        break;
        case "5":
            $this->log_out();
        break;
        case "6":
            $this->create_new();
        break;
        case "7":
            $this->install();
        break;
        case "8":
            $this->download();
        break;
        case "9":
            $this->show_key();
        break;
        default :
            $this->show_uploadlist();
    }
}
else{if(($query[1]!='4')||($query[1]!='8')){$this->log_in();}}
}
}
?>