<?php
/*
Copyright (c) 2008 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class mail extends clsmain
{
private function show_messagelist($page)
{
        $this->build_head('Inbox', '','');
        $result = @$this->con->query("SELECT id FROM ".PREFIX."inbox");
        $num_rows = @$result->num_rows;
        if($num_rows <= 0){echo '<div style="margin:20px; font-size:18px;">Your Inbox is empty!</div>';}
        else{
			$start_count=($page-1)*$this->list_perpage;
			$end_count=($start_count+$this->list_perpage)-1;
			if($end_count>=$num_rows){$end_count=$num_rows-1;}
			$totalpage=fw_total_page($num_rows, $this->list_perpage);
			$query  = "SELECT id, new, subject, name, date FROM ".PREFIX."inbox ORDER BY id Desc LIMIT ".$start_count.", ".$this->list_perpage;
			$result = @$this->con->query($query);
			echo '<table id="list"><tr><td class="heading" style="width:60%;">Subject</td><td class="heading" width="20%">From</td><td class="heading" style="width:20%;">Date</td></tr>';
			while($row = @$result->fetch_array(MYSQL_ASSOC))
			{
				if($row['new']){$src='<img title="New" src="images/mailunread.gif" alt="N" />';$style='font-weight:600;color:#000;';}
				else{$src='<img title="Read" src="images/mailread.gif" alt="R" />';$style='font-weight:500;color:#333;';}
				echo '<tr onMouseOver="this.className=\'highlight\'" onMouseOut="this.className=\'normal\'"><td>'.$src;
				echo '<a style="'.$style.'" href="index.php?qur=5M1M'.$row['id'].'">'.$row['subject'].'</a></td>';
				echo '<td>'.$row['name'].'</td><td>'.gmdate("M d, Y, H:i", $row['date']).'</td></tr>';
			}
			echo '<tr><td colspan="3"><b>No. of pages:&nbsp;'.$totalpage.'</b>&nbsp;&nbsp;&nbsp;';
			for($p=1; $p<=$totalpage; $p++){
			   if($p==$page){echo '<span style="color:#808080;">['.$p.']</span>&nbsp;';}
			   else{echo '[<a href="index.php?qur=5M6M'.$p.'">'.$p.'</a>]&nbsp;';}
			}
			echo '</td></tr></table>';}
        echo '</div>';
        $this->build_footer();
}

private function show_message($id)
{
        $hmenu='<li><a href="index.php?qur=5M6M1">Inbox</a></li><li><a href="javascript:fwDelete('.$id.')">Delete</a></li><li><a href="index.php?qur=5M3M'.$id.'">Save text</a></li><li><a href="index.php?qur=5M4M'.$id.'">Save html</a></li>';
        $this->build_head('Message'.$id,'<script type="text/javascript" src="script/mail.js"></script>',$hmenu);
        $query=sprintf("SELECT* FROM ".PREFIX."inbox WHERE id = %u",$id);
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
        echo '<div class="partition"><table cellspacing="2" style="width:100%;" cellpadding="2"><tr><td width="80px"><b>From</b>:</td><td colspan="2"><a href="mailto:'.$row['email'].'">'.$row['name'].'</a></td></tr><tr><td><b>Sender IP</b>:</td><td colspan="2">'.$row['ip'].'</td></tr><tr><td><b>Subject</b>:</td><td colspan="2">'.$row['subject'].'</td></tr><tr><td><b>Date</b>:</td><td>'.gmdate("M d, H:i", $row['date']).'</td><td colspan="2" style="text-align: right">';
        echo 'Reply:&nbsp; <a href="index.php?qur=5M7M0M'.$id.'">Text</a> | <a href="index.php?qur=5M7M1M'.$id.'">HTML</a> </td></tr><tr><td colspan="3" style="border-top:1px solid #666;padding-top:10px;">'.nl2br($row['message']).'</td></tr></table></div></div>';
        if($row['new']){@$this->con->query(sprintf("UPDATE ".PREFIX."inbox SET new = 0 WHERE id = %u",$id));}
        $this->build_footer();
}
public function get_query($query='')
{
        if ($this->validate_user()){
              switch ($query[1]) {
                  case "1":
                      $this->show_message($query[2]);
                  break;
                  case "2":
                      $this->delete_message($query[2]);
                  break;
                  case "3":
                      $this->savemessage_text($query[2]);
                  break;
                  case "4":
                      $this->savemessage_html($query[2]);
                  break;
                  case "5":
                      $this->log_out();
                  break;
                  case "6":
                      $this->show_messagelist($query[2]);
                  break;
                  case "7":
                      $this->show_mailform($query[2],$query[3]);
                  break;
                  case "8":
                      $this->send_mail($query[2]);
                  break;
                  case "9":
                      $this->show_configuration();
                  break;
                  case "10":
                      $this->save_configuration();
                  break;
                  default :
                      $this->show_messagelist(1);
              }
        }
        else { $this->log_in();}
}

private function show_configuration()
{
        $query="SELECT* FROM ".PREFIX."mailsettings";
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
        $this->build_head('Auto responder','<script type="text/javascript" src="script/mail.js"></script>','');
        include "include/editmailconfig.php";
        $this->build_footer();
}

private function show_mailform($type, $id='')
{
        $query="SELECT defaultfrom, reply FROM ".PREFIX."mailsettings";
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
        $from=$row['defaultfrom'].'@'.str_replace("www.","", strtolower(getenv("HTTP_HOST")));
        $reply=$row['reply'];
        $message='/////Type your message text here./////';
        if($type==1){
            $message="<html>\r\n<head>\r\n<title>Write message title</title>\r\n</head>\r\n<body>\r\n<!-- write your message here -->\r\n";}
        if($id!==''){
            $query=sprintf("SELECT id, name, email, subject, message FROM ".PREFIX."inbox WHERE id = %u",$id);
            $result = @$this->con->query($query);
            $row = @$result->fetch_array(MYSQL_ASSOC);
            $row['subject']="Reply: ".$row['subject'];
            if($type==1){$message.="\r\n\r\n<p>------------------------------------<br />".$row['name']." wrote:<br />\r\n".$row['message']."</p>\r\n";}
            else{$message.="\r\n\r\n----------------------------------\r\n\r\n".$row['name']." wrote:\r\n".$row['message']."\r\n";}}
        if($type==1){$message.="\r\n</body>\r\n</html>";}
        $title=(($type==0)? 'Send text message' : 'Send html message');
        $hmenu=($id!=='')? '<li><a href="index.php?qur=5M1M'.$row['id'].'">Back to message</a></li>':'';
		$this->build_head($title,'<script type="text/javascript" src="script/mail.js"></script>',$hmenu);
		$action='index.php?qur=5M8M'.$type;
        include "include/mailform.php";
        $this->build_footer();
}

private function save_configuration()
{
        $defaultfrom=fw_strip_slashes(trim($_POST['defaultfrom']));
        $reply=fw_strip_slashes(trim($_POST['reply']));
        $autoresponder=fw_strip_slashes(trim($_POST["autoresponder"]));
        $query="UPDATE ".PREFIX."mailsettings SET defaultfrom = '%s', reply = '%s', autoresponder = '%s'";
		$query=sprintf($query,$this->con->real_escape_string($defaultfrom),$this->con->real_escape_string($reply),$this->con->real_escape_string($autoresponder));
        if(@$this->con->query($query)){echo '<script>parent.document.getElementById("feedback").innerHTML="<span style=\"color:green; background:#ffffff;\">Page has been successfully updated!</span>";</script>';}
        else{echo '<script>parent.document.getElementById("feedback").innerHTML="<span style=\"color:red; background:#ffffff;\">Fail to update page! Please try again later.</span>";</script>';}
        exit;
}

private function send_mail($type)
{
        $to=fw_strip_slashes($_POST['to']);
        $cc=fw_strip_slashes($_POST['cc']);
        $bcc=fw_strip_slashes($_POST['bcc']);
        $from=fw_strip_slashes($_POST['from']);
        $reply=fw_strip_slashes($_POST['reply']);
        $subject=fw_strip_slashes($_POST['subject']);
        $message=fw_strip_slashes($_POST['message']);
        $headers='';
        if($type==1){//Html message
            $headers.="MIME-Version: 1.0" . "\r\n";
            $headers.="Content-type: text/html; charset=iso-8859-1" . "\r\n";
        }
		else{
			$message=xss_cleaner($message);
			$subject=xss_cleaner($subject);}
        $headers.="From: ".$from."\r\n";
        if(!(empty($reply))){$headers.="Reply-To: ".$reply."\r\n";}
        if(!(empty($cc))){$headers.="Cc: ".$cc."\r\n";}
        if(!(empty($bcc))){$headers.="Bcc: ".$bcc."\r\n";}
        if(@mail($to,$subject,$message,$headers)){echo '<script>parent.document.getElementById("feedback").innerHTML="<span style=\"color:green; background:#ffffff;\">Your mail has been suscessfully send</span>";</script>';}
        else{echo '<script>parent.document.getElementById("feedback").innerHTML="<span style=\"color:red; background:#ffffff;\">Sorry! Failed to send mail. Please again later.</span>";</script>';}
		exit;
}
private function savemessage_html($message_number)
{
        $query=sprintf("SELECT* FROM ".PREFIX."inbox WHERE id = %u",$message_number);
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
        $s='<html><head><title>Message'.$message_number.'</title></head><body><div style="width:600px;">';
        $s.='From:&nbsp;<a href="mailto:'.$row['email'].'">'.$row['name'].'</a><br />I.P.:&nbsp;' .$row['ip'].'<br />Subject:&nbsp;'.$row['subject'].'<br />Date:&nbsp;'.gmdate("M d, H:i", $row['date']).'<br /><hr />'.str_replace("\r","",str_replace("\n","<br />",$row['message'])).'</div></body></html>';
        $f='message'.$message_number.'.html';
        @header("Content-type: application/text");
        @header("Content-Disposition: attachment; filename=$f");
        echo $s;
        exit;
}
private function savemessage_text($message_number)
{
        $query=sprintf("SELECT* FROM ".PREFIX."inbox WHERE id = %u",$message_number);
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
        $s="From: ".$row['name']." (".$row['email'].")\r\nI.P.: ".$row['ip']."\r\nSubject: ".$row['subject']."\r\nDate: ".gmdate("M d, H:i", $row['date'])."\r\n".str_repeat("_",45)."\r\n\r\n".html_entity_decode($row['message']);
        $f='message'.$message_number.'.rtf';
        @header("Content-type: application/text");
        @header("Content-Disposition: attachment; filename=$f");
        echo $s;
        exit;
}
private function delete_message($message_number)
{
        $query = sprintf("DELETE FROM ".PREFIX."inbox  WHERE id = %u",$message_number);
        @$this->con->query($query);
        @header("Location: index.php?qur=5M");
}
}
?>