<?php
/*
Copyright (c) 2008 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class clsmain
{
protected $site;
protected $con;
protected $list_perpage=50;
protected $adminLogin=false;
function __construct()
{
        include '../database/config.php';
		if(empty($dbname)||empty($dbuser)){exit;}
		$con=@new mysqli($dbhost,$dbuser,$dbpw,$dbname);
		$this->con=$con;
 		$con->set_charset("utf8");
        $query  = "SELECT* FROM ".PREFIX."settings";
        $result = $con->query($query);
        $this->site = $result->fetch_array(MYSQL_ASSOC);
		@$result->free();
}
protected function preview_pagename($name)
{
		$pos=strrpos($name,'/');
		return ($pos===false)? ('preview:'.$name):(substr($name,0,$pos).'/preview:'.substr($name,$pos+1));
}
protected function validate_user()
{
        if ($this->validate_pw()){return true;}
        $query  = "SELECT login, session FROM ".PREFIX."admin";
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
        if(isset($_SESSION['fw_admin'])&&($_SESSION['fw_admin']===$row['session']) && ($_SERVER['REMOTE_ADDR']==$row['login'])){$this->adminLogin=true;return true;}
        return false;
}

private function validate_pw()
{
        if(empty($_POST['password'])||empty($_POST['name'])){return false;}
        $_SESSION['fw_try']=((isset($_SESSION['fw_try']))? 1+$_SESSION['fw_try'] : 1);
        if($_SESSION['fw_try'] > 10){return false;}
        $name=bin2hex(htmlspecialchars(fw_strip_slashes(trim($_POST['name']))));
        $pass=md5(fw_strip_slashes(trim($_POST['password'])));
        $query = "SELECT* FROM ".PREFIX."admin";
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
        if(($pass==$row['password'])&&($name==bin2hex($row['user']))){
            $random=fw_random();
            $random=substr($random,0,12);
            $_SESSION['fw_admin']=$random;
            $_SESSION['fw_try']=0;
            $addr=$_SERVER["REMOTE_ADDR"];
            $query="UPDATE ".PREFIX."admin SET login = '$addr', session = '$random'";
            if(@$this->con->query($query)!==false){$this->adminLogin=true;return true;}
        }
        return false;
}

protected function log_out()
{
        unset($_SESSION['fw_admin']);
		$this->adminLogin=false;
        $query = "UPDATE ".PREFIX."admin SET login =''";
        @$this->con->query($query);
        $this->log_in();
}

protected function log_in()
{
        if(file_exists("../database/newlogin.php")){
              $this->update_password();
              $message='<div style="background:#dfdfdf; clear:both; padding:5px; color:#338833;"><b>Your user name and password has been updated.</b></div>';}
        $this->build_head('Login','','<script type="text/javascript" src="script/admin.js"></script>');
        include "include/login.php";
        $this->build_footer();
}

protected function build_head($title, $script='',$hmenu)
{
        if($this->adminLogin){
            $query="SELECT a.m, b.c FROM (select count(id) as m FROM ".PREFIX."inbox WHERE new = 1) as a left join (select count(id) as c FROM ".PREFIX."comments where publish = 0) AS b on true";
            $result=@$this->con->query($query);
            $row = @$result->fetch_array(MYSQL_ASSOC);
            $leftmenu= str_replace('__I__',$row['m'],str_replace('__C__',$row['c'],file_get_contents('include/vmenu.txt')));
        }
        else{
            $hmenu= '<li><a href="index.php">Login</a></li>';
            $hmenu.= '<li><a href="index.php?qur=8M2">Forget password</a></li>';
        }
        include "include/head.php";
}

protected function build_footer()
{
        include "include/footer.html";
        exit;
}
private function forget_password()
{
        if((empty($_POST['newname']))||(empty($_POST['newpw']))){
             $this->build_head('Forget password','<script type="text/javascript" src="script/forget.js"></script>','');
             include "include/forget.php";
             $this->build_footer();
        }
        else{
             $s='<?php exit; ?>'."\n";
             $s.='//Do not edit this file. Please upload it to your '.DOCROOT.'fw_blog/database/ directory.'."\n";
             $s.=$_POST['newname'].'< >'.md5(fw_strip_slashes($_POST['newpw']));
             $filename='newlogin.php';
             @header("Content-type: application/text");
             @header("Content-Disposition: attachment; filename=$filename");
             echo $s;
             return;
        }
}

private function update_password()
{
        if(($lines=@file("../database/newlogin.php"))===false){return;}
        $data=explode('< >',$lines[2]);
        $newuser=$data[0];
        $newpassword=trim($data[1]);
        $query=sprintf("UPDATE ".PREFIX."admin SET user = '%s', password = '%s'",$this->con->real_escape_string($newuser),$this->con->real_escape_string($newpassword));
        @$this->con->query($query);
        @unlink("../database/newlogin.php");
}

public function get_query($query='')
{
    if ($this->validate_user()){
          switch ($query[1]) {
          case "5":
              $this->log_out();
          break;
          case "3":
              $this->page_editor($query[2],$query[3]);
          break;
          case "4":
              $this->save_page($query[2],$query[3],$query[4]);
          break;
          case "6":
              $this->compress();
          break;
          case "7":
              $this->download_compress();
          break;
          default :
              exit;}
    }
    else {
         switch ($query[1]){
          case "2":
              $this->forget_password();
          break;
          default :
              $this->log_in();}}
}

private function page_editor($id,$index)
{
        if($index==2){
			$result = @$this->con->query(sprintf("SELECT pagename, content FROM ".PREFIX."postinf WHERE id = %d",$id));
			$row = @$result->fetch_array(MYSQL_ASSOC);
			$pagename=$row['pagename'];
			$content=$row['content'];}
        else{
			$result = @$this->con->query(sprintf("SELECT pagename FROM ".PREFIX."pageinf WHERE id = %d",$id));
			$row = @$result->fetch_array(MYSQL_ASSOC);
			$pagename=$row['pagename'];
			$content=@file_get_contents('../pages/'.str_replace('/','.',$pagename).'.php');}
        $headers=@file_get_contents('../headers/'.str_replace('/','.',$pagename).'.php');
        $str='<html><head><title>Edit:'.$pagename.'</title><script type="text/javascript" src="script/common.js"></script><script type="text/javascript" src="script/editor.js"></script>';
		$str.='<style>
        <!--
        body, textarea{font-family:\'courier new\'; font-size:13px;line-height:140%;color:#333360;}
        body{height:100%;}
		span{color:#888;font:600 12px arial;text-decoration:underline;}
        a, a span{color:#0000ff;text-decoration:underline;font:600 12px arial;}
        -->
        </style></head>
        <body>
        <form name="frmEdit" style="margin:0; background:#dddddd; padding:0; min-width:600px; border:1px solid #cccccc; height:94%;" onSubmit="return(false);">
        <div style="background:#eeeeee url(\'images/bg.png\') repeat-x; padding:10px; clear:both; height:20px;">
        <div style="float:left; margin-bottom:10px;">
		<span id="c">Content</span> |
		<span id="h"><a href="javascript:fwShowHeader();">Header</a></span> |
        <a href="javascript:fwSaveDocument('.$id.','.$index.',false);"><span id="s">Save Content</span></a> |
        <a href="javascript:fwSaveDocument('.$id.','.$index.',true);">Save all</a> |
        <a href="javascript:window.close();">Close</a>
        </div>
        <div id="feedback" style="float:right; clear:right;"></div>
        </div>
        <textarea style="padding:5px;width:100%; height:96%; border:none;" name="txtContent" id="content" cols="20" rows="1" onClick="javascript:fwClearFeedback();">';
        $str.=htmlspecialchars($content,ENT_QUOTES).'</textarea>';
        $str.='<textarea style="width:100%; height:96%; border:none; padding:5px; background: #ece9d8; display:none;" name="txtHeader" id="header" cols="20" rows="1" onClick="javascript:fwClearFeedback();">';
        $str.=htmlspecialchars($headers,ENT_QUOTES).'</textarea>';
        $str.='</form></body></html>';
        echo $str;
}

private function save_page($id,$index,$mode)
{
		$dt=time();
        $content=fw_strip_slashes(trim(rawurldecode($_POST['content'])));
        $header=fw_strip_slashes(trim(rawurldecode($_POST['header'])));
        $result=@$this->con->query(sprintf("SELECT pagename FROM ".PREFIX.(($index==2)? "postinf" : "pageinf")." WHERE id = %d",$id));
        $row = @$result->fetch_array(MYSQL_ASSOC);
		$pagename=$row['pagename'];
		$query="UPDATE ".PREFIX.(($index==2)? ("postinf SET updated = $dt".((($mode==0)||($mode==2))? ", content = '%s'" : "")) : "pageinf SET updated = $dt")." WHERE id = %d";
        if(($index==2)&&(($mode==0)||($mode==2))){$query=sprintf($query,$this->con->real_escape_string($content),$id);}
		else{$query=sprintf($query,$id);}
		if(!(@$this->con->query($query))){echo '<img src="images/close.gif" style="border:none;" /><span style="font-weight:600; color:red; margin-bottom:2px;">Sorry! unable to save document.</span>';exit;}
        if(($index==1)&&(($mode==0)||($mode==2))){if(!($this->create_page($row['pagename'],$content))){echo '<img src="images/close.gif" style="border:none;" /><span style="font-weight:600; color:red; margin-bottom:2px;">'.$this->con->error.'Sorry! unable to save document.</span>';exit;}}
        if($mode>0){if(!($this->create_header($row['pagename'],$header))){echo '<img src="images/close.gif" style="border:none;" /><span style="font-weight:600; color:red; margin-bottom:2px;">Sorry! unable to save document.</span>';exit;}}
        echo '<img src="images/right.gif" style="border:none;" /><span style="font-weight:600; color:green; margin-bottom:2px;">Document has been updated.</span>';
        exit;
}

protected function create_page($page,$content='')
{
		$filename='../pages/'.str_replace('/', '.',$page).'.php';
		$handle=@fopen($filename, 'w');
        @fwrite($handle, $content);
        return @fclose($handle);
}
protected function create_header($page,$content)
{
        $filename='../headers/'.str_replace("/", ".",$page).'.php';
        if(empty($content)){return ((file_exists($filename))? @unlink($filename) : true);}
        $handle=@fopen($filename, 'w');
        @fwrite($handle, $content);
        return @fclose($handle);
}
}
?>