<?php
/*
Copyright (c) 2008 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class page extends clsmain
{
private function show_preview()
{
		$pagename=trim(fw_strip_slashes($_POST["pagename"]));
		if(!fw_validate_pagename($pagename)){exit;}
		$pagename=$this->preview_pagename($pagename);
		$title=trim(fw_strip_slashes($_POST["title"]));
		$heads=trim(fw_strip_slashes($_POST["heads"]));
		$content=trim(fw_strip_slashes($_POST["content"]));
		$dt=time();
		$query="UPDATE ".PREFIX."preview SET title = '%s', heads = '%s', content = '%s', pagename = '%s', date = $dt";
		$query=sprintf($query,$this->con->real_escape_string($title),$this->con->real_escape_string($heads),$this->con->real_escape_string($content),$this->con->real_escape_string($pagename));
		@$this->con->query($query);
		foreach (glob("../pages/*preview:*.php") as $filename){@unlink($filename);}
		if($this->create_page($pagename,$content)){
			$_SESSION['fw_preview']=$pagename;
			echo '<script>parent.previewPage("http://'.getenv('HTTP_HOST').DOCROOT.$pagename.'.html");</script>';
		}
		exit;
}
private function show_edit($id='')
{
		$action='index.php?qur=1M7M'.(empty($id)? '0':$id).'M';
		$menu='<li><a href="index.php?qur=1M">Page list</a></li>';
        if(!empty($id)){
            $query=sprintf("SELECT* FROM ".PREFIX."pageinf WHERE id = %d",$id);
            $result = @$this->con->query($query);
            $row = @$result->fetch_array(MYSQL_ASSOC);
			$menu.='<li><a href="javascript:fwDelete('.$id.')">Delete file</a></li><li><a href="javascript:fwPublish('.$id.')"><span id="publish">'.(($row['publish'])? 'Block' : 'Publish').'</span></a></li>';
			$headerfile='../headers/'.str_replace('/', '.', $row['pagename']).'.php';
			$headers=(is_file($headerfile)? @file_get_contents($headerfile):'');
			$contentfile='../pages/'.str_replace('/', '.', $row['pagename']).'.php';
			$content=(is_file($contentfile)? @file_get_contents($contentfile):'');
		}
		$this->build_head('Create page || Edit page','<script type="text/javascript" src="script/editpage.js"></script>',$menu);
        include "include/editpage.php";
        $this->build_footer();
}
private function delete_page($id)
{
		$query=sprintf("SELECT pagename FROM ".PREFIX."pageinf WHERE id = %u",$id);
		$result = @$this->con->query($query);
		$row = @$result->fetch_array(MYSQL_ASSOC);
		$headerfile='../headers/'.str_replace('/', '.', $row['pagename']).'.php';
		$contentfile='../pages/'.str_replace('/', '.', $row['pagename']).'.php';
		if(is_file($headerfile)){@unlink($headerfile);}
		if(is_file($contentfile)){@unlink($contentfile);}
		$query = sprintf("DELETE FROM ".PREFIX."pageinf WHERE id = %u",$id);
		@$this->con->query($query);
		@header("Location: index.php?qur=1M");
}

private function edit_page($id='',$overwrite)
{
		if(isset($_POST['btnPreview'])){$this->show_preview();}
		$pagename=trim(fw_strip_slashes($_POST["pagename"]));
		if(!fw_validate_pagename($pagename)){fw_message(true,'Error: Invaliv pagename!');exit;}
		if(substr($pagename,0,5)==='fw_blog/'){fw_message(true,'Error: please do not create page in your blog directory');exit;}
		$headers=fw_strip_slashes(trim($_POST["headers"]));
		$title=trim(fw_strip_slashes($_POST["title"]));
		$description=trim(fw_strip_slashes($_POST["description"]));
		$description=str_replace("\n"," ",str_replace("\r","",$description));
		while(strpos($description,'  ')!==false){$description=str_replace('  ',' ',$description);}
		$keywords=trim(xss_cleaner(fw_strip_slashes($_POST["keywords"])));
		$keywords=str_replace("\n"," ",str_replace("\r","",$keywords));
		while(strpos($keywords,'  ')!==false){$keywords=str_replace('  ',' ',$keywords);}
		$heads=fw_strip_slashes(trim($_POST["heads"]));
		$content=fw_strip_slashes(trim($_POST["content"]));
		$indexed=empty($_POST["indexed"])? 0 : 1;
		$new=true;
		$dt=time();

		if($overwrite=='1'){$new=false;}
		else{
			$result = @$this->con->query(sprintf("SELECT id FROM ".PREFIX."postinf WHERE pagename = '%s'",$this->con->real_escape_string($pagename)));
			$num_rows = @$result->num_rows;
			if(!empty($num_rows)){fw_message(true,'Error: a post of same pagename is already there!');exit;}
			$result = @$this->con->query(sprintf("SELECT id FROM ".PREFIX."pageinf WHERE pagename = '%s'",$this->con->real_escape_string($pagename)));
			$row = @$result->fetch_array(MYSQL_ASSOC);
			if(!empty($row)){
				if((empty($id))||($row['id']!=$id)){echo '<script>parent.fwConfirm();</script>';exit;}
				$new=false;}
		}

		if($new){$query="INSERT INTO ".PREFIX."pageinf(title, description, keywords, heads, indexed, date, updated, pagename) VALUES ('%s', '%s', '%s', '%s', $indexed, $dt, $dt, '%s')";}
		else{$query="UPDATE ".PREFIX."pageinf SET title = '%s', description = '%s', keywords = '%s', heads = '%s', indexed = $indexed, updated = $dt WHERE pagename = '%s'";}
		$query=sprintf($query,$this->con->real_escape_string($title),$this->con->real_escape_string($description),$this->con->real_escape_string($keywords),$this->con->real_escape_string($heads),$this->con->real_escape_string($pagename));
		if(!$this->create_page($pagename,$content)){fw_message(true,'Error: Unable to create page content. Please check file permission.');exit;}
		if(!$this->create_header($pagename,$headers)){fw_message(true,'Error: Unable to modify header file. Please check file permission.');exit;}
		if(!(@$this->con->query($query))){fw_message(true,$this->con->error);exit;}
		if($new){$id=$this->con->insert_id;echo '<script>parent.location.href="index.php?qur=1M1M'.$id.'";</script>';}
		else{fw_message(false,'Data has been suscessfully updated');}
		exit;
}

public function get_query($query='')
{
if ($this->validate_user()){
switch ($query[1]) {
    case "6":
        $this->show_list($query[2]);
    break;
    case "7":
        $this->edit_page($query[2], $query[3]);
    break;
    case "1":
        $this->show_edit($query[2]);
    break;
    case "2":
        $this->delete_page($query[2]);
    break;
    case "3":
        $this->publish_page($query[2]);
    break;
    case "4":
        $this->show_fw_preview();
    break;
    case "5":
        $this->log_out();
    break;
    default :
        $this->show_list(1);
}
}
else{if(($query[1]!='4')||($query[1]!='7')){$this->log_in();}}
}
private function re_install()
{

}
private function show_list($page)
{
        $search='';
        $sortDir='Desc';
        $sortCol='id';
        if(!empty($_GET['sortCol'])){$sortCol=fw_strip_slashes($_GET['sortCol']);}
        if(!empty($_GET['sortDir'])){$sortDir=fw_strip_slashes($_GET['sortDir']);}
        if(!empty($_GET['SearchFileString'])){$search=fw_strip_slashes($_GET['SearchFileString']);}
        $this->build_head('Page list','','');
        $result = @$this->con->query(sprintf("SELECT id FROM ".PREFIX."pageinf WHERE pagename LIKE '%%%s%%'",$this->con->real_escape_string($search)));
        $num_rows = @$result->num_rows;
        $start_count=($page-1)*$this->list_perpage;
        $totalpage=fw_total_page($num_rows, $this->list_perpage);

        echo '<div style="width:100%; overflow-x:scroll;"><table id="list"><tr><td class="heading" style="width:75%;"><a href="index.php?qur=1M6M1&SearchFileString='.$search.'&sortCol=pagename&sortDir=Asc"><img src="images/up.gif" onmouseover="this.src=\'images/uph.gif\'" onmouseout="this.src=\'images/up.gif\'" /></a><a href="index.php?qur=1M6M1&SearchFileString='.$search.'&sortCol=pagename&sortDir=Desc"><img src="images/dn.gif" onmouseover="this.src=\'images/dnh.gif\'" onmouseout="this.src=\'images/dn.gif\'" /></a><b>File name</b></td>';
		echo '<td colspan="2" class="heading" style="border-right:none;"><a href="index.php?qur=1M6M1&SearchFileString='.$search.'&sortCol=updated&sortDir=Asc"><img src="images/up.gif" onmouseover="this.src=\'images/uph.gif\'" onmouseout="this.src=\'images/up.gif\'" /></a><a href="index.php?qur=1M6M1&SearchFileString='.$search.'&sortCol=updated&sortDir=Desc"><img src="images/dn.gif" onmouseover="this.src=\'images/dnh.gif\'" onmouseout="this.src=\'images/dn.gif\'" /></a><b>Last modified</b></td></tr>';
        echo '<tr><td colspan="3"><big>*</big>&nbsp;<a href="index.php?qur=1M1M">Create new</a></td></tr>';
        $query="SELECT id, pagename, title, updated, publish FROM ".PREFIX."pageinf WHERE ";
		$query.="pagename LIKE '%%%s%%' ORDER BY $sortCol $sortDir LIMIT ".$start_count.", ".$this->list_perpage;
		$query=sprintf($query,$this->con->real_escape_string($search));
        $result = @$this->con->query($query);
        while($row = @$result->fetch_array(MYSQL_ASSOC))
        {
            echo '<tr onMouseOver="this.className=\'highlight\'" onMouseOut="this.className=\'normal\'">';
			$src='<img title="Published" src="images/approved.gif" alt="P" />';
			if(empty($row['title'])){$src='<img title="No title" src="images/notitle.gif" alt="T" />';}
			if(!$row['publish']){$src='<img title="Unpublished" src="images/unpublished.gif" alt="U" />';}
            echo '<td>'.$src;
            echo '<a href="index.php?qur=1M1M'.$row['id'].'">'.$row['pagename'];
            echo '</a></td>';
			echo '<td style="text-align:center;">';
			echo ((($row['publish'])&&!empty($row['title']))? '<a href="http://'.getenv('HTTP_HOST').DOCROOT.$row['pagename'].'.html" target="_blank">View</a>' : '<span style="color:#888888; font-family:tahoma;">View</span>');
			echo ' | <a href="javascript:fw_openEditor('.$row['id'].',1)">Edit</a></td>';
            echo '<td>'.gmdate("M d, H:i", $row['updated']).'</td></tr>';
        }

        echo '<tr><td colspan="3"><b>No. of pages:&nbsp;'.$totalpage.'</b>&nbsp;&nbsp;&nbsp;';

        $start=(($page>10)? $page-10 : 1);
        $end=(($totalpage<=21)? $totalpage : $start+20);
        echo(($page>1)? '<a href="index.php?qur=1M6M'.($page-1).'&SearchFileString='.$search.'&sortCol='.$sortCol.'&sortDir='.$sortDir.'">Back</a>&nbsp;' : '<span style="color:#808080;">Back</span>&nbsp;');
        for($p=$start; $p<=$end; $p++){
             if($p==$page){echo '<span style="color:#808080;">['.$p.']</span>&nbsp;';}
             else{echo '[<a href="index.php?qur=1M6M'.$p.'&SearchFileString='.$search.'&sortCol='.$sortCol.'&sortDir='.$sortDir.'">'.$p.'</a>]&nbsp;';}
        }
        echo(($page<$totalpage)? '<a href="index.php?qur=1M6M'.($page+1).'&SearchFileString='.$search.'&sortCol='.$sortCol.'&sortDir='.$sortDir.'">Next</a>&nbsp;' : '<span style="color:#808080;">Next</span>&nbsp;');

        echo '</td></tr>';
        echo '<tr><td colspan="3" style="background:#e0e0e0; padding-bottom:0;">';
        echo '<form name="frmSearchList" style="float:right; margin:0; color:#000000;" onSubmit="return fw_search(\'index.php?qur=1M6M1\');">';
        echo 'Search file:&nbsp;<input name="txtSearch" style="padding-left:5px; width:180px; font-size:11px; color:#666666;" type="text" value="';
        echo (($search=='')? 'Type first few characters...' : $search);
        echo '" size="20" onClick="fw_cleartext(this);">&nbsp;<input name="Submit" type="button" style="width:80px; font-size:11px; color:#333333;" value="Search" onClick="fw_search(\'index.php?qur=1M6M1\');"></form></td></tr></table></div>';
        echo '</div>';
        $this->build_footer();
}
private function publish_page($id)
{
        $query=sprintf("SELECT publish FROM ".PREFIX."pageinf WHERE id = %u",$id);
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
		if($row['publish']){$publish=0;$response='Publish';}
		else{$publish=1;$response='Block';}
        $query=sprintf("UPDATE ".PREFIX."pageinf SET publish = $publish WHERE id = %u",$id);
        if(@$this->con->query($query)){echo $response;}exit;
}
}
?>