<?php
/*
Copyright (c) 2008 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
?>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>Install Ramui Webblog</title>
<script type="text/javascript" src="../script/common.js"></script>
<script type="text/javascript">
function validateForm(){
var errors='';
if (fw_trim(document.frmInstall.dbname.value).length<1){
errors+='Database name missing!\n';
}
if (fw_trim(document.frmInstall.dbuser.value).length<1){
errors+='Database user name missing!\n';
}
if (fw_trim(document.frmInstall.dbpw.value).length<1){
errors+='Database password missing!\n';
}
if (fw_trim(document.frmInstall.dbhost.value).length<1){
errors+='Database host name missing!\n';
}
var str=fw_trim(document.frmInstall.author.value);
if(!str.match(/^([a-zA-Z0-9\.\ ]){5,100}$/)){errors+='Write your correct name between 5 to 100 characters\n';}
errors+=fw_checkuser(document.frmInstall.admin.value);
errors+=fw_checkpassword(document.frmInstall.password.value);

str=fw_trim(document.frmInstall.email.value);
if (!((str.indexOf(".") > 0) && (str.indexOf("@") > 0)&&(str.length < 100))){
errors+='Enter correct email id\n'; }

if (errors){
alert('Following error(s) occurred:\n'+errors);
return false; }
return true;
}
function generatePW(){document.frmInstall.password.value=fw_generatepassword();}
</script>
<style type="text/css">
.caption{
font:600 13px arial;
border-bottom: 1px solid #888;
margin: 10px 10px 10px 5px;
padding-bottom:2px;
clear:right;
}
body{margin:0;padding:0;font:500 12px arial;}
td{font:500 12px arial;}
a{color:#3355aa;}
ul{
list-style-type:square;
margin:7px 7px 20px 7px;
list-style-position:inherit;
padding-left:40px;
}
li{
margin:5px 0 0 10px;
padding:0 0 3px 0;
}
#footer{
clear:both;
padding:10px 0;
border-top:1px solid #888;
text-align:center;
color:#666;
}
#footer a{color:#666;}
#feedback{font-weight:500;font-size:11px;margin: 10px; clear:both;}
.text{
height:30px;
width:230px;
font-size:14px;
font-family:'courier new';
padding:2px;
border:1px solid #bcb0a0;
}
.text:hover{
background:#faf9f8;
}
form{
margin:0;
padding:0;
}
</style>
</head><body>
<center>
<div style="border:1px solid #aaa;border-radius:5px;margin:8px 0 20px 0;padding:10px;width:950px;text-align:left;">
<div style="clear:both;height:70px;">
<img src="../images/caption.gif" style="margin:0;float:left;" />
<div style="float:right;"><a href="http://ramui.com/webblog/ramui-webblog-installation.html">Documentation</a> | <a href="http://ramui.com/forum/index.php?f=16">Help</a></div>
<div id="feedback"></div>
</div>
<iframe name="formSubmit" id="formSubmit" style="display:none;"></iframe>
<div id="success">
<form action="index.php" method="post" target="formSubmit" name="frmInstall" id="frmInstall" OnSubmit="return validateForm()">
<div class="caption">Database Information:</div>
<table cellpadding="4" cellspacing="4" style="margin:5px 20px 20px 20px;">
<tr>
<td width="180px">Database name:</td>
<td><input class="text" type="text" name="dbname" size="20"></td>
<td rowspan="5" style="padding:5px 10px;"><b>Important!</b><br />
Before installation set permission of the file "database/config.php" to "0644" or simply "644".
<span style="display:block; margin:0px; color:#777777;">__________________________________<br />
*If you are not sure please accept default values.</span></td>
</tr>
<tr>
<td width="180px">Database user name:</td>
<td><input class="text" type="text" name="dbuser" size="20"></td>
</tr>
<tr>
<td width="180px">Database password:</td>
<td><input class="text" type="password" name="dbpw" size="20"></td>
</tr>
<tr>
<td width="180px">*Database host name:</td>
<td><input class="text" type="text" name="dbhost" size="20" value="localhost"></td>
</tr>
<tr>
<td width="180px">*Table prefix:</td>
<td><input class="text" type="text" name="prefix" size="20" value="fw_"></td>
</tr>
</table>
<div class="caption">User Information:</div>
<table cellpadding="4" cellspacing="4" style="margin:5px 20px 30px 20px;">
<tr>
<td width="180px">Real name:</td>
<td><input class="text" type="text" name="author" size="20"></td>
<td rowspan="3" style="padding:0px 20px;"><b>Important!</b><br />
Use only alphanumeric characters in "User name".
</tr>
<tr>
<td width="180px">User name&nbsp;&nbsp;(5 to 10 ch):</td>
<td><input class="text" type="text" name="admin" size="20"></td></tr><tr>
<td width="180px">Password&nbsp;[&nbsp;<a href="javascript:generatePW()">Generate</a>&nbsp;]:</td>
<td><input class="text" type="text" name="password" size="20"></td>
</tr>
<tr><td>Email address:</td><td><input class="text" type="text" name="email" size="20"></td>
</table>
<div style="text-align:center; clear:both;">
<input name="Submit" type="submit" class="button" value="Submit">&nbsp;&nbsp;<input id="Reset" type="reset" class="button" value="Reset"></div>
</form></div>
</div></center></body>