<?php
/*
Copyright (c) 2008 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class database
{
private $con;
private $site;
private $admin=false;
public $edit=false;
public $totalpage=false;
public $script='';
function __construct()
{
        $message=$this->connection();
		if((($this->site['blocksite'])&&(!$this->admin))||($message)){include 'fw_blog/include/errormessage.php';exit;}
}
private function connection()
{
        include 'fw_blog/database/config.php';
		if(empty($dbname)||empty($dbuser)){include 'fw_blog/include/readme.php';exit;}
		$con=@new mysqli($dbhost,$dbuser,$dbpw,$dbname);
        if(mysqli_connect_errno()){return mysqli_connect_error();}
		$this->con=$con;
 		$con->set_charset("utf8");
        $query  = "SELECT* FROM ".PREFIX."settings";
        $result = $con->query($query);
		if($con->error){return $con->error;}
        $this->site = $result->fetch_array(MYSQL_ASSOC);
		@$result->free();
		$this->validate_user();return;
}
private function validate_user()
{
        $query  = "SELECT login, session FROM ".PREFIX."admin";
        $result= $this->con->query($query);
        $row=$result->fetch_array(MYSQL_ASSOC);
        $this->admin=(isset($_SESSION['fw_admin'])&&($_SESSION['fw_admin']===$row['session']) && ($_SERVER['REMOTE_ADDR']==$row['login']));
}
public function siteinf($param=''){return((empty($param))? $this->site : $this->site[$param]);}
public function get_page_array($pagename)
{
		$page_array=array();
		if(isset($_SESSION['fw_preview'])&&strpos($pagename,':')&&($this->admin)){$page_array=$this->pagepreview();}
		else{
			$this->webstat($pagename);
			$query = sprintf("(SELECT 'x' AS post, id FROM ".PREFIX."postinf WHERE pagename = '%s' AND publish = 1) union all (SELECT 'y' AS post, id FROM ".PREFIX."pageinf WHERE pagename = '%s' AND publish = 1)",$this->con->real_escape_string($pagename),$this->con->real_escape_string($pagename));
			$result= $this->con->query($query);
			$row=$result->fetch_array(MYSQL_ASSOC);
			if($row['post']==='x'){$page_array=$this->postinf($pagename);}
			elseif($row['post']==='y'){$page_array=$this->pageinf($pagename);}
		}
        return $page_array;
}
private function pagepreview()
{
        $query = "SELECT* FROM ".PREFIX."preview";
        $result= $this->con->query($query);
        $row=$result->fetch_array(MYSQL_ASSOC);
        unset($_SESSION['fw_preview']);
        $this->format_content($row['content'],0);
        return $row;
}
private function pageinf($page)
{
        $query = sprintf("SELECT* FROM ".PREFIX."pageinf WHERE pagename = '%s' AND publish = 1",$this->con->real_escape_string($page));
        $result= $this->con->query($query);
        $row=$result->fetch_array(MYSQL_ASSOC);
        return $row;
}
private function postinf($post)
{
		$query=sprintf("SELECT* FROM ".PREFIX."postinf WHERE pagename = '%s' AND publish = 1",$this->con->real_escape_string($post));
        $result= $this->con->query($query);
        $row=$result->fetch_array(MYSQL_ASSOC);
		if(empty($row)){return false;}
		$this->format_content($row['content'],$row['id']);
		if((substr_count($row['content'],'<fw_pagebreak />'))>0){
			$this->totalpage=1+substr_count($row['content'],'<fw_pagebreak />');
			$page=fw_get_querydata('fw_pageno');
			if((empty($page))||(!preg_match('/^[0-9]{1,2}$/u', $page))){$page=1;}
			if($page<$this->totalpage){$row['allowcomments']=0;}
			$row['content']=fw_get_currentpagecontent($row['content'],$page);
		}
        
        while($this->find_addon($row['heads'])){}
        $row['heads']=str_replace('{UPLOAD_URL}',UPLOAD_URL,$row['heads']);
        while($this->find_dynamic($row['content'])){}
        if($this->admin){$this->edit=true;}
        return $row;
}
public function get_comments($id,$structure)
{
        $query=sprintf("SELECT tc.*, tu.user, tu.website FROM ".PREFIX."comments tc, ".PREFIX."user tu WHERE tu.id = tc.uid AND tc.pid = %u AND tc.publish = 1 ORDER BY tc.date",$id);
        $result= $this->con->query($query);
        $s=file_get_contents($structure);
		$str='';
		$nofollow=($this->site['nofollow']);
		$autolink=($this->site['autolink']);
		$bb= new bbcode($nofollow);
        while($row = @$result->fetch_array(MYSQL_ASSOC)){
			$comment=$bb->format_text($row['comment'],$autolink);
			if($row['website']==''){$user=$row['user'];}
			else{$user='<a'.(($nofollow)? ' rel="nofollow"':'').' href="'.((strpos($row['website'],'http')===false)? 'http://'.$row['website'] : $row['website']).'" target="_blank">'.$row["user"].'</a>';}
			$str.=str_replace(array('__&TITLE__','__&USER__','__&DATE__','__&COMMENT__'),array($row['title'],$user,gmdate("M d, H:i", $row['date']),$comment),$s);
		}
		@$result->free();
		unset($bb);
        return $str;
}
private function webstat($pagename)
{
        $browser=$_SERVER['HTTP_USER_AGENT'];
		$browser_low=strtolower($browser);
		$bots=array('google','msnbot','rambler','yahoo','abachobot','accoona','acoirobot','aspseek','croccrawler','dumbot','fast-webcrawler','geonabot','gigabot','lycos','msrbot','scooter','altavista','idbot','estyle','scrubby');
        foreach ($bots as $b){if(stristr($browser_low, $b)){return;}}
		unset($bots);
		$ip=$_SERVER['REMOTE_ADDR'];
        $frompage = '';
		$new=0;
        $dt=time();
        if(empty($_COOKIE['fw_currentsession'])){
			$identifier=str_replace('.','',$_SERVER['REMOTE_ADDR']).$dt;
			setcookie('fw_currentsession',$identifier,0,DOCROOT);
			$_COOKIE['fw_currentsession']=$identifier;
			if(!isset($_COOKIE['fw_identifier'])){@setcookie('fw_identifier',$identifier,$dt+3600*24*365,DOCROOT,'',false,true);$new=1;}
			$this->store_keywords($pagename,$dt);
			$frompage=substr($this->con->real_escape_string(@$_SERVER['HTTP_REFERER']),0,250);
		}
        $query="INSERT INTO ".PREFIX."webstat(pagename, frompage, user, ip, browser, minutes, new, date) VALUES ('%s', '%s', '%s', '%s', '%s', 0, $new, $dt)";
        $query=sprintf($query,$this->con->real_escape_string($pagename),$frompage,$this->con->real_escape_string(@$_COOKIE['fw_currentsession']),$this->con->real_escape_string($ip),$this->con->real_escape_string($browser));
		if(@$this->con->query($query)){$this->script.="var fwStatID=".$this->con->insert_id.";\nfwLoadStat();\n";}
}
private function store_keywords($pagename,$dt)
{
        $from=@$_SERVER['HTTP_REFERER'];
		$referrer=parse_url($from,PHP_URL_HOST);
		$q='q';
		if((strpos($from,'http://www.google.')!==0)&&(strpos($from,'http://www.bing.com/search?')!==0)){
			if(strpos($from,'yahoo.com/')===false){return;}
			else{$q='p';}
		}
		$key=fw_get_querydata($q,$from);
		if(empty($key)){return;}
        $query=sprintf("INSERT INTO ".PREFIX."keywords(pagename, searchengine, searchkey, date) VALUES ('%s','%s','%s', $dt)",$this->con->real_escape_string($pagename),$this->con->real_escape_string($referrer),$this->con->real_escape_string(substr(urldecode($key),0,250)));
        @$this->con->query($query);
}
private function format_content(&$content,$pid)
{
        while($this->find_code($content,$pid)){}
        while($this->find_addon($content)){}
        $content=str_replace('{UPLOAD_URL}',UPLOAD_URL,$content);
}
private function find_code(&$content,$pid)
{
		$content=preg_replace('/<codx>(.+)<\/codx>/eiUs', "\$this->get_code('\\1',\$pid)", $content);return false;
}
private function get_code($raw_code,$pid)
{
		static $n=0;
		$n=$n+1;
		$line_count=substr_count($raw_code,"\n");
		$height=20+($line_count-1)*15;
		if($height<50){$height=50;}
		if($height>300){$height=300;}
		$code=htmlspecialchars(stripslashes($raw_code),ENT_NOQUOTES);
		if(!empty($pid)){$code=str_replace('%&lt;%','<',str_replace('%&gt;%','>',$code));}
		$download_url=BLOG_URL.'fw_blog/extend.php?query=4M'.$pid.'M'.$n;
		return '<div class="fw_code_heading" id="fw_code'.$n.'">'.LAN_CODE.(($pid=='')? ':' : ' | <a class="fw_codedownload" href="'.$download_url.'">'.LAN_DOWNLOAD.'</a>').'</div><pre class="fw_code" style="padding:5px; overflow:auto; height:'.$height.'px;">'.$code.'</pre>';
}
private function find_addon(&$content)
{
        $content=preg_replace('/<addon>(.+)<\/addon>/eiUs', "\$this->get_addon('\\1')", $content);return false;
}
public function get_recentpost($count='',$dsc)
{
		if(empty($count)){$count=5;}
		$query="SELECT pagename, title FROM ".PREFIX."postinf WHERE publish = 1 AND addtomenu = 1 ORDER BY id Desc LIMIT 0, $count";
		if($dsc){
			$query="SELECT tp.pagename, tp.title, tp.description, tp.allowcomments, b.cc AS c FROM ";
			$query.=PREFIX."postinf tp LEFT JOIN (SELECT pid, COUNT(id) AS cc  FROM ".PREFIX."comments WHERE publish = 1 GROUP BY pid) AS b ON tp.id = b.pid WHERE tp.publish = 1 AND tp.addtomenu = 1 AND tp.description <> '' GROUP BY tp.id ORDER BY tp.id Desc LIMIT 0, $count";}
		$result= $this->con->query($query);
		while($row=$result->fetch_array(MYSQL_ASSOC)){
			$url=BLOG_URL.$row['pagename'].'.html';
			$recent.='<li class="fw_title"><h2><a href="'.$url.'">'.htmlspecialchars($row['title']).'</a></h2></li>';
			if($dsc){
				$recent.='<li class="fw_description">'.htmlspecialchars($row['description']).'</li>';
				if(($row['allowcomments'])||($row['c'])){
					   $recent.='<li class="fw_comment" style="text-align:right;">';
					   $recent.=empty($row['c'])? ('0 '.LAN_COMMENT): ('<a href="'.$url.'#comments">'.$row['c'].' '.(($row['c']>1)? LAN_COMMENTS:LAN_COMMENT).'</a>').'</li>';}
				}
		}
		return $recent;
}
public function get_toppost($count='',$dsc)
{
		if(empty($count)){$count=5;}
		$last7=time()-7*24*60*60;
		$query="SELECT tw.pagename, tp.title FROM ".PREFIX."webstat tw, ".PREFIX."postinf tp WHERE tp.publish = 1 AND tp.addtomenu = 1 AND ";
		$query.="tw.date > $last7 AND tp.pagename = tw.pagename GROUP BY tw.pagename ORDER BY SUM(tw.minutes) DESC LIMIT 0, $count";
		if($dsc){
			$query="SELECT tw.pagename, tp.title, tp.description, tp.allowcomments, b.cc AS c FROM ".PREFIX."webstat tw LEFT JOIN ".PREFIX."postinf tp ON tp.pagename = tw.pagename";
			$query.=" LEFT JOIN (SELECT pid, COUNT(id) AS cc  FROM ".PREFIX."comments WHERE publish = 1 GROUP BY pid) AS b  ON tp.id = b.pid";
			$query.=" WHERE tp.publish = 1 AND tp.addtomenu = 1 AND tp.description <> '' AND ";
			$query.="tw.date > $last7 GROUP BY tw.pagename ORDER BY SUM(tw.minutes) DESC LIMIT 0, $count";}
		$result = @$this->con->query($query);
		while($row=$result->fetch_array(MYSQL_ASSOC)){
			$url=BLOG_URL.$row['pagename'].'.html';
			$recent.='<li class="fw_title"><h2><a href="'.$url.'">'.htmlspecialchars($row['title']).'</a></h2></li>';
			if($dsc){
				$recent.='<li class="fw_description">'.htmlspecialchars($row['description']).'</li>';
				if(($row['allowcomments'])||($row['c'])){
					   $recent.='<li class="fw_comment" style="text-align:right;">';
					   $recent.=empty($row['c'])? ('0 '.LAN_COMMENT): ('<a href="'.$url.'#comments">'.$row['c'].' '.(($row['c']>1)? LAN_COMMENTS:LAN_COMMENT).'</a>').'</li>';}
				}
		}
		return $recent;
}
private function find_dynamic(&$content)
{
		$content=preg_replace('/<dynamic>(.+)<\/dynamic>/eiUs', "\$this->find_dynamic1('\\1')", $content);return false;
}
private function find_dynamic1($pagename)
{
		static $n=0;
		$n++;
		$this->script.='fwGetAddon("'.addslashes($pagename).'","fw_dynamic'.$n.'")'."\n";
		return '<div id="fw_dynamic'.$n.'"></div>';
}
public function get_addon($page)
{
        if(!fw_validate_pagename($page)){return false;}
        $query  = sprintf("SELECT content FROM ".PREFIX."addonpage WHERE pagename = '%s'",$this->con->real_escape_string($page));
        $result= $this->con->query($query);
        $row=$result->fetch_array(MYSQL_ASSOC);
		$row['content']=str_replace('{UPLOAD_URL}',UPLOAD_URL,$row['content']);
        return $row['content'];
}
public function menu($page)
{
        $m=$this->get_addon('menu_'.$page);
        if(!empty($m)){return $m;}
		if($this->site['automenu']){
			include "fw_blog/include/menu.php";
			switch($this->site['menutype']){
                case "3":
                    $clsmenu=new categorymenu($this->con);
                    return $clsmenu->menu($page);
                break;
                case "2":
                    $clsmenu=new javascriptmenu($this->con);
                    return $clsmenu->menu();
                break;
                case "1":
                    $clsmenu=new simplemenu($this->con);
                    return $clsmenu->menu($page);
                break;
                default:
                return false;
			}
		}
		else{return $this->get_addon('menu');}
}
private function arrange(&$array,$folder)
{
		$str='';
		foreach($array as $key => $item)
		{
		  if(!is_array($item)){$str.=$item;}
		  else{
				$str.='<li class="fw_directory"><a href="'.BLOG_URL.$folder.'/'.$key.'/index.html">'.$key.'</a><ul>';
				$str.=$this->arrange($item,$folder.'/'.$key);}
		}
		$str.='</ul></li>';
		return $str;
}
private function fw_list_item(&$parent,$item,$title,$pagename)
{
		$pos=strpos($item,'/');
		if($pos===false){$parent[]='<li><a href="'.BLOG_URL.$pagename.'.html">'.$title.'</a></li>'; return;}
		else{
			$dir=substr($item,0,$pos);
			$newitem=substr($item,$pos+1);
			if(!array_key_exists($dir,$parent)){$parent[$dir]=array();}
			$this->fw_list_item($parent[$dir],$newitem,$title,$pagename);
		}
}
public function get_sitemap_tree()
{
        $folders=array();
        $docroot='';
		$sitemap='';
        $query="(SELECT pagename, title FROM ".PREFIX."postinf WHERE publish = 1 AND indexed = 1 ORDER BY date DESC) union all (SELECT pagename, title FROM ".PREFIX."pageinf WHERE publish = 1 AND indexed = 1 ORDER BY date DESC) LIMIT 0,300";
        $result = @$this->con->query($query);
        while($row = @$result->fetch_array(MYSQL_ASSOC))
        {
                if(($pos=strpos($row['pagename'],'/'))===false){$docroot.='<li><a href="'.BLOG_URL.$row['pagename'].'.html">'.htmlspecialchars($row['title']).'</a></li>';}
                else{$this->fw_list_item($folders,$row['pagename'],$row['title'],$row['pagename']);}
        }
        foreach($folders as $key => $f){
                $sitemap.='<li class="fw_directory"><a href="'.BLOG_URL.$key.'/index.html">'.$key.'</a><ul>';
                $sitemap.=$this->arrange($f,$key);}
        if(!empty($docroot)){$sitemap=$docroot.$sitemap;}
        if($sitemap!=''){$sitemap='<h1>'.LAN_SITEMAP_HEADING.'</h1><div id="fw_sitemap"><ul>'.$sitemap.'</ul></div>';}
        return $sitemap;
}
public function get_sitemap_list($structure)
{
        $s='';
//No. of pages.
		$page=fw_get_querydata('fw_pageno');
		if((empty($page))||(!preg_match('/^[0-9]{1,2}$/u', $page))){$page=1;}
        $query= "(SELECT 'x' AS type, id FROM ".PREFIX."postinf WHERE indexed = 1 AND publish = 1) union all (SELECT 'y' AS type, id FROM ".PREFIX."pageinf WHERE indexed = 1 AND publish = 1)";
        $result= $this->con->query($query);
        $num_rows = @$result->num_rows;
		$start_count=($page-1)*$this->site['listperpage'];
		$this->totalpage=fw_total_page($num_rows, $this->site['listperpage']);
		$str=file_get_contents($structure);
		$list=$this->gettag('list',$str);
		$description=$this->gettag('description',$list);
		$str=preg_replace('/\<list\>(.+)\<\/list\>/Us','',$str);

        $query= "(SELECT pagename, title, description, updated FROM ".PREFIX."pageinf WHERE indexed = 1 AND publish = 1 AND title <> '' ORDER BY pagename) union all (SELECT pagename, title, description, updated FROM ".PREFIX."postinf WHERE indexed = 1 AND publish = 1 AND title <> '' ORDER BY pagename) LIMIT $start_count, ".$this->site['listperpage'];
		$result= $this->con->query($query);
		while($row=$result->fetch_array(MYSQL_ASSOC)){
			$s.=str_replace(array('__&TITLE__','__&UPDATE__'),array('<a href="'.BLOG_URL.$row['pagename'].'.html">'.htmlspecialchars($row['title']). '</a>',gmdate("M d, H:i", $row['updated'])),$list);
			$row['description']=empty($row['description'])? '': str_replace('__&DESCRIPTION__',htmlspecialchars($row['description']),$description);
			$s=preg_replace("/<description>(.+)<\/description>/Us",$row['description'],$s);
			$s=preg_replace("/<comments>(.+)<\/comments>/Us",'', $s);
		}
		$str=str_replace('__&LIST__',$s,str_replace('__&DIR__',LAN_SITEMAP_HEADING,$str));
		return $str;
}
public function gettag($name,&$x)
{
		$start=strpos($x,'<'.$name.'>')+strlen($name)+2;
		return substr($x,$start,strpos($x,'</'.$name.'>')-$start);
}
public function get_directory($d,$structure)
{
        $s='';
		$page=fw_get_querydata('fw_pageno');
		if((empty($page))||(!preg_match('/^[0-9]{1,2}$/u', $page))){$page=1;}
        $query= sprintf("(SELECT id FROM ".PREFIX."pageinf WHERE pagename LIKE \"%s%%\" AND indexed = 1 AND publish = 1) union all (SELECT id FROM ".PREFIX."postinf WHERE pagename LIKE \"%s%%\" AND indexed = 1 AND publish = 1)",$this->con->real_escape_string($d),$this->con->real_escape_string($d));
        $result= $this->con->query($query);
        $num_rows = @$result->num_rows;
//Total page to be displayed.
		$start_count=($page-1)*$this->site['listperpage'];
		$this->totalpage=fw_total_page($num_rows, $this->site['listperpage']);
		$str=file_get_contents($structure);
		$list=$this->gettag('list',$str);
		$description=$this->gettag('description',$list);
		$comments=$this->gettag('comments',$list);
		$str=preg_replace('/\<list\>(.+)\<\/list\>/Us','',$str);

		$query="(SELECT tp.pagename, tp.title, tp.description, tp.updated, tp.allowcomments, IF(ISNULL(b.cc), 0, b.cc) AS c FROM ";
		$query.=PREFIX."postinf tp LEFT JOIN (SELECT pid, COUNT(id) AS cc  FROM ".PREFIX."comments WHERE publish = 1 GROUP BY pid) AS b ON tp.id = b.pid WHERE tp.pagename LIKE \"%s%%\" AND tp.indexed = 1 AND tp.publish = 1 GROUP BY tp.id ORDER BY tp.updated Desc) union all ";
		$query.="(SELECT pagename, title, description, updated, 0 AS allowcomments, 0 AS c FROM ";
		$query.=PREFIX."pageinf WHERE pagename LIKE \"%s%%\" AND indexed = 1 AND publish = 1 ORDER BY tp.updated Desc) LIMIT $start_count, ".$this->site['listperpage'];
		$query=sprintf($query,$this->con->real_escape_string($d),$this->con->real_escape_string($d));
		$result= $this->con->query($query);
		while($row = @$result->fetch_array(MYSQL_ASSOC)){
			$s.=str_replace(array('__&TITLE__','__&UPDATE__'),array('<a href="'.BLOG_URL.$row['pagename'].'.html">'.htmlspecialchars($row['title']). '</a>',gmdate("M d, H:i", $row['updated'])),$list);
			$row['description']=empty($row['description'])? '': str_replace('__&DESCRIPTION__',htmlspecialchars($row['description']),$description);
			$s=preg_replace("/<description>(.+)<\/description>/Us",$row['description'],$s);
			$row['c']=((($row['allowcomments'])||($row['c']))? str_replace('__&COMMENTS__',(empty($row['c'])? ('0 '.LAN_COMMENT): ('<a href="'.BLOG_URL.$row['pagename'].'.html#comments">'.$row['c'].' '.(($row['c']>1)? LAN_COMMENTS:LAN_COMMENT).'</a>')),$comments):'');
			$s=preg_replace('/\<comments\>(.+)\<\/comments\>/Us',$row['c'],$s);
		}
        $dir=str_replace('_',' ',str_replace('-',' ',substr($d,0,-1)));
		$str=str_replace('__&LIST__',$s,str_replace('__&DIR__',$dir,$str));
        return $str;
}
}
?>