<?php
/*
Copyright (c) 2008 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class extension
{
private $con;
private $site;
function __construct()
{
        include 'database/config.php';
		if(empty($dbname)||empty($dbuser)){exit;}
		$con=@new mysqli($dbhost,$dbuser,$dbpw,$dbname);
		$this->con=$con;
 		$con->set_charset("utf8");
        $query  = "SELECT* FROM ".PREFIX."settings";
        $result = $con->query($query);
		if($con->error){return $con->error;}
        $this->site = $result->fetch_array(MYSQL_ASSOC);
		@$result->free();
}
public function get_query()
{
		if(!preg_match('/^([M0-9]){2,50}$/',htmlentities($_GET['query']))){exit;}
		$query=@$_GET['query'];
		$qur= explode("M", $query);
		switch ($qur[0]){
			case "1":
				$this->show_comment($qur[1]);
			break;
			case "2":
				$this->save_comment($qur[1]);
			break;
			case "3":
				$this->contact();
			break;
			case "4":
				$this->download($qur[1],$qur[2]);
			break;
			case "5":
				$this->update_stat($qur[1]);
			break;
			case "7":
				$this->add_dynamic();
			break;
			default: exit;
		}
}
private function show_comment($id)
{
		if((isset($_COOKIE['fw_user']))&&(preg_match('/^([a-zA-Z0-9]){5,16}+(\|\|)+([a-zA-Z0-9\-\._@\|]){7,110}$/',$_COOKIE['fw_user']))){$login=explode('||',$_COOKIE['fw_user']);}
		$action='extend.php?query=2M'.$id;
		$defaultstyle=$this->site['defaultstyle'];
		include 'templates/'.$this->site['defaultstyle'].'/add_comment.php';
}
private function save_comment($pid)
{
		$err='';
		if((empty($_SESSION['verifyComment']))||(md5($_POST['verifyComment'])!==($_SESSION['verifyComment']))){$err.=LAN_ERROR_VERIFICATION.'\n';}
		$query=sprintf("SELECT publish, allowcomments FROM ".PREFIX."postinf WHERE id = %u",$pid);
		$result=@$this->con->query($query);
		$row = @$result->fetch_array(MYSQL_ASSOC);
		if((empty($row['allowcomments']))||(empty($row['publish']))){exit;}
        $title=xss_cleaner(trim(fw_strip_slashes($_POST["title"])));
		if(strlen($title)>80){$err.=LAN_ERROR_TITLE.'\n';}
        $comment=xss_cleaner(trim(fw_strip_slashes($_POST["fw_editor"])));
		if(strlen($comment)>$this->site['commentsize']){$err.=LAN_ERROR_COMMENT_MAX.$this->site['commentsize'].'\n';}
		if(strlen($comment)<50){$err.=LAN_ERROR_COMMENT_MIN.'\n';}
        $user=xss_cleaner(trim(fw_strip_slashes($_POST["user"])));
        $email=xss_cleaner(trim(fw_strip_slashes($_POST["from"])));
		if(!fw_validate_user($user,$email)){$err.=LAN_ERROR_USER_EMAIL.'\n';}
        $website=xss_cleaner(trim(fw_strip_slashes($_POST["website"])));
		if(!empty($website)){
			if(!verify_url($website)){$err.=LAN_ERROR_URL.'\n';}
			elseif(strlen($website)>100){$err.=LAN_ERROR_URL_LENGTH.'\n';}
		}
		if($err!=''){echo '<script>alert("'.LAN_ERROR_LIST.':\n'.$err.'");parent.fwVerificationImage("verifyComment");</script>';exit;}
        $dt=time();
        if(!empty($_POST['rememberme'])){setcookie('fw_user', $user.'||'.$email, time()+60*60*24*30*12,'/');}
        else{setcookie('fw_user','',time()-3600,'/');}

        $query=sprintf("SELECT id, level FROM ".PREFIX."user WHERE user = '%s' AND email = '%s'",$this->con->real_escape_string($user),$this->con->real_escape_string($email));
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
		$uid=$row['id'];
        if(!(empty($uid))){
			if($row['level']<1){
				echo fw_error(LAN_USER_BAN);
				exit;}}
        if(empty($uid)){
            $query=sprintf("SELECT id FROM ".PREFIX."user WHERE user = '%s'",$this->con->real_escape_string($user));
            $result = @$this->con->query($query);
            $row = $result->fetch_array(MYSQL_ASSOC);
            if(!empty($row['id'])){
                echo fw_error(LAN_USER_EXIST);
                exit;}
            $query=sprintf("SELECT id FROM ".PREFIX."user WHERE email = '%s'",$this->con->real_escape_string($email));
            $result = @$this->con->query($query);
            $row = @$result->fetch_array(MYSQL_ASSOC);
            if(!empty($row['id'])){
                echo fw_error(LAN_EMAIL_EXIST);
                exit;}
            $query = "INSERT INTO ".PREFIX."user(user, email, website, level, date) VALUES ('%s', '%s', '%s', 9, $dt)";
			$query=sprintf($query,$this->con->real_escape_string($user),$this->con->real_escape_string($email),$this->con->real_escape_string($website));
            if(!(@$this->con->query($query))){
                echo fw_error(LAN_ERROR_SYSTEM);
                exit;}
			$uid=$this->con->insert_id;
        }
		$publish=$this->site['approval'];
        $query = "INSERT INTO ".PREFIX."comments(pid, uid, title, comment, publish, date) VALUES (%u, %u, '%s', '%s', $publish, $dt)";
		$query=sprintf($query,$pid,$uid,$this->con->real_escape_string($title),$this->con->real_escape_string($comment));
        unset($_SESSION['verifyComment']);
        if(!(@$this->con->query($query))){echo fw_error(LAN_ERROR_SYSTEM);}
        else{
			if($publish){echo '<script>parent.opener.location.reload(true);parent.document.getElementById("feedback").innerHTML="<span style=\"color:green; font-size:12px;\">'.LAN_COMMENT_PUBLISH.'<br /><a href=\"javascript:window.close();\"><b>'.LAN_CLOSE_WINDOW.'</b></a>.</span>";</script>';}
			else{echo '<script>parent.document.getElementById("feedback").innerHTML="<span style=\"color:green; font-size:12px;\">'.LAN_COMMENT_WAITING.'<br /><a href=\"javascript:window.close();\"><b>'.LAN_CLOSE_WINDOW.'</b></a>.</span>";</script>';}
		}
}
private function contact()
{
        $err='';
		if((empty($_SESSION['verifyContact']))||(md5($_POST['verifyContact'])!==($_SESSION['verifyContact']))){$err.=LAN_ERROR_VERIFICATION.'\n';}
		$dt=time();
		$name=xss_cleaner(trim(fw_strip_slashes($_POST['name'])));
		$length=strlen($name);
		if(($length>40)||($length<3)){$err.=LAN_ERROR_NAME.'\n';}
		$subject=xss_cleaner(trim(fw_strip_slashes($_POST['subject'])));
		if(strlen($subject)>78){$err.=LAN_ERROR_SUBJECT.'\n';}
		if(empty($subject)){$subject="Message from $name";}
		$from=xss_cleaner(trim(fw_strip_slashes($_POST['from'])));
		if(!fw_validate_email($from)){$err.=LAN_ERROR_EMAIL.'\n';}
		$message=xss_cleaner(trim(fw_strip_slashes($_POST['message'])));
		if((strlen($message)>5000)||(strlen($message)<50)){$err.=LAN_ERROR_MESSAGE.'\n';}
		if($err!=''){echo '<script>alert("'.LAN_ERROR_LIST.':\n'.$err.'");parent.fwVerificationImage("verifyContact");</script>';exit;}
		unset($_SESSION['verifyContact']);
		$ip=$_SERVER['REMOTE_ADDR'];
		$query="INSERT INTO ".PREFIX."inbox(name,subject, email, message, ip, new, date) VALUES ('%s','%s','%s', '%s', '%s', 1, $dt)";
		$query=sprintf($query,$this->con->real_escape_string($name),$this->con->real_escape_string($subject),$this->con->real_escape_string($from),$this->con->real_escape_string($message),$this->con->real_escape_string($ip));
		if(@$this->con->query($query)){
			$result=@$this->con->query("SELECT* FROM ".PREFIX."mailsettings");
			$row= @$result->fetch_array(MYSQL_ASSOC);
			if(!empty($row['autoresponder'])){
				$autoresponder=$row['autoresponder'];
				$reply_from=$row['defaultfrom'].'@'.str_replace("www.","", strtolower(getenv("HTTP_HOST")));
				$autoresponder=str_ireplace("%%SENDER%%",$name,$autoresponder);
				$autoresponder=str_ireplace("%%EMAIL%%",$from,$autoresponder);
				$autoresponder=str_ireplace("%%MESSAGE%%",$message,$autoresponder);
				@mail($from,'Re: '.$subject, $autoresponder, 'From: '.$reply_from);}
			echo '<script>parent.document.getElementById("feedback").innerHTML="<span style=\"color:green; font-size:12px;\">'.LAN_MESSAGE_SENT.'</span>";parent.fwVerificationImage("verifyContact");</script>';}
		else{echo fw_error(LAN_ERROR_SYSTEM);}
}
private function download($pid,$n)
{
		$query=sprintf("SELECT pagename,content FROM ".PREFIX."postinf WHERE id = %d",$pid);
        $result= @$this->con->query($query);
        $row= @$result->fetch_array(MYSQL_ASSOC);
        $pos=0;
        for($i=0; $i<$n; $i++){
              $pos=strpos($row['content'],'<codx>',$pos)+6;
              if($pos===false){return;}}
		$end=strpos($row['content'],'</codx>',$pos);
		$raw_code=substr($row['content'],$pos,($end-$pos));
        $raw_code=str_replace("\n","<br />",htmlspecialchars($raw_code,ENT_NOQUOTES));
        $raw_code='<html><head><title>_Code'.$n.'</title></head><body>'.str_replace('%&lt;%','<',str_replace('%&gt;%','>',$raw_code));
        $raw_code.='<hr/><p>Source: <a href="'.BLOG_URL.$row['pagename'].'.html">'.BLOG_URL.$row['pagename'].'.html</a></p></body></html>';
        $filename=$row['pagename'].'_code'.$n.'.html';
        @header("Content-type: application/text");
        @header("Content-Disposition: attachment; filename=$filename");
        echo $raw_code;exit;
}
private function update_stat($id)
{
        $count=$_POST['count'];
		$dt=time()-600;
		$query="UPDATE ".PREFIX."webstat SET minutes = %d WHERE user = '%s' AND id = %d";
		$query=sprintf($query,$count,$this->con->real_escape_string($_COOKIE['fw_identifier']),$id);
        @$this->con->query($query);exit;
}
private function add_dynamic()
{
        $page=trim(htmlspecialchars(fw_strip_slashes(rawurldecode($_POST['addon']))));
        if(($page=='')||(!fw_validate_pagename($page))){exit;}
        $query=sprintf("SELECT content FROM ".PREFIX."addonpage WHERE pagename = '%s'",$this->con->real_escape_string($page));
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
        echo $row['content'];exit;
}
}
?>