<?php
class clsmenu
{
protected $con;
function __construct(&$connection)
{
		$this->con=$connection;
}
protected function topfive()
{
        $menu='';
        $last7=time()-7*24*60*60;
        $query="SELECT tw.pagename, tp.title FROM ".PREFIX."webstat tw, ".PREFIX."postinf tp WHERE ";
        $query.="tp.publish = 1 AND tp.addtomenu = 1 AND tw.date > $last7 AND tp.pagename = tw.pagename GROUP BY tw.pagename ORDER BY SUM(tw.minutes) DESC LIMIT 0, 5";
        $result = @$this->con->query($query);
        while($row = @$row=$result->fetch_array(MYSQL_ASSOC)){$menu.='<li><a href="'.BLOG_URL.$row['pagename'].'.html">'.htmlspecialchars($row['title']).'</a></li>';}
        @$result->free();
        return $menu;
}
}
class simplemenu extends clsmenu
{
public function menu()
{
        $folders=array();
        $query="SELECT pagename, title FROM ".PREFIX."postinf WHERE publish = 1 AND addtomenu = 1 ORDER BY date Desc LIMIT 0,150";
        $result = @$this->con->query($query);
        while($row = @$row=$result->fetch_array(MYSQL_ASSOC))
        {
			if(($pos=strpos($row['pagename'],'/'))!==false){
			   $folder_name=substr($row['pagename'],0,$pos);
			   if(array_key_exists($folder_name,$folders)==false){$folders[$folder_name]='<ul><li class="separator"><span>'.str_replace('_',' ',$folder_name).'</span></li>';}
			   $folders[$folder_name].='<li><a href="'.BLOG_URL.$row['pagename'].'.html">'.htmlspecialchars($row['title']).'</a></li>';}
			else{
			   if(array_key_exists(LAN_DOCUMENT_ROOT,$folders)==false){$folders[LAN_DOCUMENT_ROOT]='<ul><li class="separator"><span>'.LAN_DOCUMENT_ROOT.'</span></li>';}
			   $folders[LAN_DOCUMENT_ROOT].='<li><a href="'.BLOG_URL.$row['pagename'].'.html">'.htmlspecialchars($row['title']).'</a></li>';}
        }
        @$result->free();
        $menu='<div class="fw_menu">';
        foreach($folders as $f){$menu.=$f."</ul>\r\n";}
        return $menu.'</div>';
}
}
class categorymenu extends clsmenu
{
public function menu($page)
{
        if(($pos=strpos($page,'/'))!==false){$search=substr($page,0,$pos);}
		else{$search='';}
		$query="SELECT pagename, title FROM ".PREFIX."postinf WHERE publish = 1 AND addtomenu = 1 ORDER BY updated DESC LIMIT 0, 500";
        $result = @$this->con->query($query);
        $folders=array();
        $recentfiles=array();
		$files='';
		$count=0;
		$menu='';
        while($row = @$row=$result->fetch_array(MYSQL_ASSOC))
        {
        //Add recent files.
			if(count($recentfiles)<5){$recentfiles[]='<li><a href="'.BLOG_URL.$row['pagename'].'.html">'.htmlspecialchars($row['title']).'</a></li>';}
		//Add directory listing.
			if(($pos=strpos($row['pagename'],'/'))!==false){
				$folder_name=substr($row['pagename'],0,$pos);
				if(in_array($folder_name,$folders)==false){$folders[]=$folder_name;}
				if($folder_name===$search){$count++;if($count<101){$files.='<li><a href="'.BLOG_URL.$row['pagename'].'.html">'.htmlspecialchars($row['title']).'</a></li>';}}
			}
			else{
				if(in_array(LAN_DOCUMENT_ROOT,$folders)==false){$folders[]=LAN_DOCUMENT_ROOT;}
				if(empty($search)){$files.='<li><a href="'.BLOG_URL.$row['pagename'].'.html">'.htmlspecialchars($row['title']).'</a></li>';}
			}
        }
        foreach($recentfiles as $file){$menu.=$file;}
		if(!empty($menu)){$menu='<li><span class="separator">'.LAN_RECENT_FILES.'</span><ul>'.$menu.'</ul></li>';}
		$root_url='<div class="root"><a href="'.BLOG_URL.'index.html">'.LAN_DOCUMENT_ROOT.'</a></div>';
        foreach($folders as $folder){
			if(($folder===$search)||(($folder=='Document root:')&&empty($search))){
				if($folder==LAN_DOCUMENT_ROOT){$menu.='<li class="show">'.$root_url.'<ul>'.$files.'</ul></li>';}
				else{$menu.='<li class="show"><div class="root"><a href="'.BLOG_URL.$folder.'/index.html">'.str_replace('_',' ',$folder).'</a></div><ul>'.$files.'</ul></li>';}
			}
			else{
				if($folder==LAN_DOCUMENT_ROOT){$menu.='<li class="hide">'.$root_url.'</li>';}
				else{$menu.='<li class="hide"><div class="root"><a href="'.BLOG_URL.$folder.'/index.html">'.str_replace('_',' ',$folder).'</a></div></li>';}
			}
		}
        $top=$this->topfive();
		if(!empty($top)){$menu.='<li><span class="separator">'.LAN_TOP_FIVE.'</span><ul>'.$top.'</ul></li>';}
        $menu.='</ul></div>';
        $menu='<div id="fw_categorymenu"><ul>'.$menu;
        return $menu;
}
}
class javascriptmenu extends clsmenu
{
private function arrange(&$array,$folder)
{
         $str='';
         foreach($array as $key => $item)
         {
              if(!is_array($item)){$str.=$item;}
              else{
                    $str.='<li class="hide" onmouseover="this.className=\'show\'" onmouseout="this.className=\'hide\'"><a class="root" href="'.BLOG_URL.$folder.'/'.$key.'/index.html">'.$key.'</a><ul>';
                    $str.=$this->arrange($item,$folder.'/'.$key);}
         }
         $str.='</ul></li>';
         return $str;
}
private function fw_list_menu(&$parent,$item,$title,$pagename)
{
         $pos=strpos($item,'/');
         if($pos===false){$parent[]='<li><a href="'.BLOG_URL.$pagename.'.html">'.htmlspecialchars($title).'</a></li>'; return;}
         else{
                $dir=substr($item,0,$pos);
                $newitem=substr($item,$pos+1);
                if(!array_key_exists($dir,$parent)){$parent[$dir]=array();}
                $this->fw_list_menu($parent[$dir],$newitem,$title,$pagename);
         }
}
public function menu()
{
        $folders=array();
        $recentfiles='';
        $docroot='';
        $query="SELECT pagename, title FROM ".PREFIX."postinf WHERE publish = 1 AND addtomenu = 1 ORDER BY date DESC LIMIT 0,300";
        $result = @$this->con->query($query);
        $n=0;
        while($row = @$row=$result->fetch_array(MYSQL_ASSOC))
        {
                if($n<5){$recentfiles.='<li><a href="'.BLOG_URL.$row['pagename'].'.html">'.htmlspecialchars($row['title']).'</a></li>';}
                if(($pos=strpos($row['pagename'],'/'))===false){$docroot.='<li><a href="'.BLOG_URL.$row['pagename'].'.html">'.htmlspecialchars($row['title']).'</a></li>';}
                else{$this->fw_list_menu($folders,$row['pagename'],$row['title'],$row['pagename']);}
                $n++;
        }
        $menu=$this->topfive();
        if($menu!=''){$menu='<li class="separator"><span>'.LAN_TOP_FIVE.'</span></li>'.$menu;}
        $menu.='<li class="separator"><span>'.LAN_ALL_POST.'</span></li>';
        foreach($folders as $key => $f){
                $menu.='<li class="hide" onmouseover="this.className=\'show\'" onmouseout="this.className=\'hide\'"><a class="root" href="'.BLOG_URL.$key.'/index.html">'.str_replace('_',' ',$key).'</a><ul>';
                $menu.=$this->arrange($f,$key);}
        if(!empty($docroot)){$menu.='<li class="hide" onmouseover="this.className=\'show\'" onmouseout="this.className=\'hide\'"><a class="root" href="'.BLOG_URL.'index.html">'.LAN_DOCUMENT_ROOT.'</a><ul>'.$docroot.'</ul></li>';}
        if(!empty($recentfiles)){$menu.='<li class="separator"><span>'.LAN_RECENT_FILES.'</span></li>'.$recentfiles;}
        if($menu!=''){$menu='<div id="fw_jmenu"><ul>'.$menu.'</ul></div>';}
        return $menu;
}
}
?>